** FILE:
**    SWASUBM.FOR - part of program SWAP
** FILE IDENTIFICATION:
**    $Id: SWASUBM.FOR 2.3.1.16 2002/09/02 08:47:23Z Kroes Exp $
** DESCRIPTION:
**    This file contains program units of SWAP. The program units 
**    in this file are of the 2nd level and are sorted alphabetically
**    with the first letter of the program unit.
**    The following program units are in this file:
**        CROPD, GRASS, CROPS, IRRIG, METEO, SOIL, TIMER
************************************************************************
C --- SWASUBM.FOR -----------------------------------------------------
C ----------------------------------------------------------------------
      SUBROUTINE CROPD (ITASK,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &  CRPNR,CRPFIL,OUTNAM,ECRPY,ECRPD,RDS,RAD,TAV,TAVD,TMNR,TRA,PTRA,
     &  RELTR,KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,CF,DVS,ECMAX,ECSLOP,
     &  COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &  RDCTAB,RDM,LOGF,T,SWCF,sw1fil,sw1crp)
C ----------------------------------------------------------------------
C     Date               : 21/1/99
C     Purpose            : WOFOST crop growth routine for SWACROP
C     Subroutines called : RDCRP,SHIFTR,SHIFTL,NRTODA,ASTRO,TOTASS
C     Functions called   : AFGEN,LIMITR8
C     File usage         : OUTNAM.CR#, file with crop production results
C ----------------------------------------------------------------------
      IMPLICIT NONE
 
      INTEGER   CRP,CRPNR,DAYNR,YEAR,M,D,ECRPY,ECRPD,SWCF,sw1fil
      INTEGER   I1,ID,IDSL,IFINCR,ILVOLD,IPORWL,ITASK,LOGF,bayry
      integer*4 getun

      REAL*8    LAT,KDIF,LAI,LAICR,LAIEM,LAIEXP,LAIMAX,LASUM,MRES,MREST
      REAL*8    LV(300),LVAGE(300),SLA(300),CPWDM(3,300),PWSO(3,300)
      REAL*8    DTSMTB(30),SLATB(30),AMAXTB(30),TMPFTB(30),TMNFTB(30)
      REAL*8    RFSETB(30),FRTB(30),FLTB(30),FSTB(30),FOTB(30)
      REAL*8    RDRRTB(30),RDRSTB(30),CFTAB(30),RDCTAB(22)
      REAL*8    ADCRH,ADCRL,ADMI,AFGEN,AMAX,ASRC,LIMITR8,T
      REAL*8    CCHECK,CF,COSLD,CPTR0,CPTR1,CRT0,CRT1,CTR0,CTR1,CVF,CVL
      REAL*8    CVO,CVR,CVS,CWDM,DALV,DAYL,DAYLP,DELT,DLC,DLO,DMI,DRLV
      REAL*8    DRRT,DRST,DSLV,DSLV1,DSLV2,DSLVT,DTEFF,DTGA,DTSUM,DVR
      REAL*8    DVRED,DVS,DVSEND,DWLV,DWRT,DWST,EFF,FCHECK,FL,FO,FR,FS
      REAL*8    FYSDEL,GASS,GASST,GLA,GLAIEX,GLASOL,GRLV,GRRT,GRST,RDC
      REAL*8    GWRT,GWSO,GWST,ECMAX,ECSLOP,PERDL,PGASS,PTRA,Q10,RAD,RD
      REAL*8    RDI,RDM,RDS,RELTR,REST,RGRLAI,RML,RMO,RMR,RMRES,RMS,RR
      REAL*8    RRI,SINLD,SLAT,SPA,SPAN,SSA,TADW,TAV,TAVD,TBASE,RSC
      REAL*8    TDWI,TEFF,TMNR,TRA,TSUMAM,TSUMEA,TWLV,TWST,KDIR,COFAB
      REAL*8    WLV,WRT,WSO,WST,HLIM1,HLIM2L,HLIM2U,HLIM3H,HLIM3L,HLIM4
C     REAL*8    TAGP,TWRT

      CHARACTER CRPFIL*16,OUTNAM*16,FILNAM*80,ENVSTR*50
      CHARACTER EXT(3)

      LOGICAL   HDONE,FLOUT,sw1crp
  
      SAVE

      PARAMETER (DELT=1.0D0)
      DATA EXT/'1','2','3'/
C ----------------------------------------------------------------------
      GOTO (1000,2000,3000) ITASK

1000  CONTINUE

C --- INITIALIZATION ---------------------------------------------------

C --- read crop data
      CALL RDCRPD (CRPFIL,ENVSTR,SWCF,CFTAB,IDSL,DLO,DLC,TSUMEA,
     &  TSUMAM,DTSMTB,DVSEND,TDWI,LAIEM,RGRLAI,SLATB,SPA,
     &  SSA,SPAN,TBASE,KDIF,KDIR,EFF,AMAXTB,TMPFTB,TMNFTB,CVL,CVO,CVR,
     &  CVS,Q10,RML,RMO,RMR,RMS,RFSETB,FRTB,FLTB,FSTB,FOTB,PERDL,RDRRTB,
     &  RDRSTB,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &  ADCRH,ADCRL,ECMAX,ECSLOP,COFAB,RDI,RRI,RDC,RDCTAB,LOGF)

C --- maximum rooting depth & actual rooting depth
      RDM = MAX (RDI,MIN(RDS,RDC))
      RD  = RDI

C --- initial values of crop parameters
      DVS      = 0.
      FR       = AFGEN (FRTB,30,DVS)
      FL       = AFGEN (FLTB,30,DVS)
      FS       = AFGEN (FSTB,30,DVS)
      FO       = AFGEN (FOTB,30,DVS)
      SLA(1)   = AFGEN (SLATB,30,DVS)
      LVAGE(1) = 0.0
      ILVOLD   = 1

C --- initial state variables of the crop
      WRT    = FR*TDWI
      TADW   = (1.0d0-FR)*TDWI
      WST    = FS*TADW
      WSO    = FO*TADW
      WLV    = FL*TADW
      LAIEM  = WLV*SLA(1)
      LV(1)  = WLV
      LASUM  = LAIEM     
      LAIEXP = LAIEM     
      LAIMAX = LAIEM
      LAI    = LASUM+SSA*WST+SPA*WSO 
      DWRT   = 0.0
      DWLV   = 0.0
      DWST   = 0.0
      CF     = AFGEN (CFTAB,30,DVS)

C --- initial summation variables of the crop
C     TAGP   = WLV+WST+WSO
      GASST  = 0.0
      MREST  = 0.0 
      CPTR0  = 0.0
      CTR0   = 0.0
      CPTR1  = 0.0
      CTR1   = 0.0

C --- misc.
      IFINCR = 0
      IF (IPORWL.EQ.2) HDONE =.FALSE.

      RETURN

2000  CONTINUE

C --- RATES OF CHANGE OF THE CROP VARIABLES ----------------------------

C --- phenological development rate  
      CALL ASTRO (DAYNR,LAT,DAYL,DAYLP,SINLD,COSLD)

C --- increase in temperature sum
      DTSUM = AFGEN (DTSMTB,30,TAV)

      IF (DVS.LT.1.0D0) THEN     
C --- development during vegetative phase
        DVRED = 1.0D0
        IF (IDSL.GE.1.0D0) DVRED = LIMITR8 (0.0D0,1.0D0,(DAYLP-DLC)/
     &                                                 (DLO-DLC))
        DVR = DVRED*DTSUM/TSUMEA
      ELSE
C --- development during generative phase
        DVR   = DTSUM/TSUMAM
      ENDIF    

C === DAILY DRY MATTER PRODUCTION 

C --- Gross assimilation

      AMAX  = AFGEN (AMAXTB,30,DVS)
C --- correction for sub-optimum average daytemperature
      AMAX  = AMAX * AFGEN (TMPFTB,30,TAVD)
      CALL TOTASS (DAYNR,DAYL,AMAX,EFF,LAI,KDIF,RAD,SINLD,COSLD,DTGA)
C --- correction for low minimum temperature
      DTGA  = DTGA * AFGEN (TMNFTB,30,TMNR)
C --- potential assimilation in kg CH2O per ha
      PGASS = DTGA * 30.0/44.0

C --- water stress reduction of PGASS to GASS
      RELTR = LIMITR8 (0.0D0,1.0D0,TRA/PTRA)
      GASS  = PGASS * RELTR

C --- respiration and partitioning of carbohydrates between growth and
C --- maintenance respiration
      RMRES = (RMR*WRT+RML*WLV+RMS*WST+RMO*WSO)*AFGEN(RFSETB,30,DVS)
      TEFF  = Q10**((TAV-25.0D0)/10.0)
      MRES  = DMIN1(GASS,RMRES*TEFF)
      ASRC  = GASS-MRES

C --- partitioning factors
      FR = AFGEN(FRTB,30,DVS)
      FL = AFGEN(FLTB,30,DVS)
      FS = AFGEN(FSTB,30,DVS)
      FO = AFGEN(FOTB,30,DVS)
C --- check on partitioning
      FCHECK = FR+(FL+FS+FO)*(1.0D0-FR) - 1.0D0
      IF (ABS(FCHECK).GT.0.0001d0) STOP 'Partitioning error'

C --- dry matter increase
      CVF   = 1.0/((FL/CVL+FS/CVS+FO/CVO)*(1.0D0-FR)+FR/CVR)
      DMI   = CVF*ASRC
C --- check on carbon balance
      CCHECK = (GASS-MRES-(FR+(FL+FS+FO)*(1.0D0-FR))*DMI/CVF)
     &         /MAX(0.0001D0,GASS)      
      IF (ABS(CCHECK).GT.0.0001D0) STOP 'Carbon balance error'

C === GROWTH RATE BY PLANT ORGAN

C --- root extension
      RR = MIN (RDM-RD,RRI)
      IF (FR.LE.0.0D0.OR.PGASS.LT.1.0D0) RR = 0.0

C --- growth rate roots and aerial parts
      ADMI = (1.0D0-FR)*DMI
      GRRT = FR*DMI
      DRRT = WRT*AFGEN (RDRRTB,30,DVS)
      GWRT = GRRT-DRRT

C --- weight of new leaves
      GRLV = FL*ADMI

C --- death of leaves due to water stress or high LAI
      DSLV1 = WLV*(1.0D0-TRA/PTRA)*PERDL
      LAICR = 3.2/KDIF
      DSLV2 = WLV*LIMITR8(0.0D0,0.03D0,0.03*(LAI-LAICR)/LAICR)
      DSLV  = MAX (DSLV1,DSLV2) 

C --- death of leaves due to exceeding life span:

C --- first: leaf death due to water stress or high LAI is imposed 
C ---        on array until no more leaves have to die or all leaves
C ---        are gone

      REST = DSLV*DELT
      I1   = ILVOLD

100   IF (REST.GT.LV(I1).AND.I1.GE.1) THEN
        REST = REST-LV(I1) 
        I1   = I1-1
        GOTO 100
      ENDIF

C --- then: check if some of the remaining leaves are older than SPAN,
C ---       sum their weights

      DALV = 0.0
      IF (LVAGE(I1).GT.SPAN.AND.REST.GT.0.AND.I1.GE.1) THEN
        DALV = LV(I1)-REST
        REST = 0.0
        I1   = I1-1
      ENDIF

110   IF (I1.GE.1.AND.LVAGE(I1).GT.SPAN) THEN
        DALV = DALV+LV(I1)
        I1   = I1-1
      GOTO 110
      ENDIF

      DALV = DALV/DELT

C --- Finally: calculate total death rate leaves
      DRLV = DSLV+DALV

C --- physiologic ageing of leaves per time step
      FYSDEL = MAX (0.0D0,(TAV-TBASE)/(35.0D0-TBASE))

C --- specific leaf area valid for current timestep
      SLAT   = AFGEN (SLATB,30,DVS)

C --- calculation of specific leaf area in case of exponential growth:
C --- leaf area not to exceed exponential growth curve
      IF (LAIEXP.LT.6.0D0) THEN
        DTEFF  = MAX (0.0D0,TAV-TBASE)
C ---   increase in leaf area during exponential growth
        GLAIEX = LAIEXP*RGRLAI*DTEFF
C ---   source-limited increase in leaf area
        GLASOL = GRLV*SLAT
C ---   actual increase is determined by lowest value
        GLA    = MIN (GLAIEX,GLASOL)
C ---   SLAT will be modified in case GLA equals GLAIEX
        IF (GRLV.GT.0.0D0) SLAT = GLA/GRLV
      ENDIF  

C --- growth rate stems
      GRST = FS*ADMI
C --- death rate stems
      DRST = AFGEN (RDRSTB,30,DVS)*WST
C --- net growth rate stems
      GWST = GRST-DRST

C --- growth rate storage organs
      GWSO = FO*ADMI

C ----INTEGRALS OF THE CROP --------------------------------------------

C --- phenological development stage
      DVS    = DVS+DVR*DELT

C --- leaf death (due to water stress or high LAI) is imposed on array 
C --- untill no more leaves have to die or all leaves are gone

      DSLVT = DSLV*DELT
      I1    = ILVOLD
120   IF (DSLVT.GT.0.AND.I1.GE.1) THEN
        IF (DSLVT.GE.LV(I1)) THEN
          DSLVT  = DSLVT-LV(I1)
          LV(I1) = 0.0
          I1     = I1-1
        ELSE
          LV(I1) = LV(I1)-DSLVT
          DSLVT  = 0.0
        ENDIF
      GOTO 120
      ENDIF 

C --- leaves older than SPAN die
130   IF (LVAGE(I1).GE.SPAN.AND.I1.GE.1) THEN
        LV(I1) = 0.0
        I1     = I1-1
      GOTO 130
      ENDIF

C --- oldest class with leaves
      ILVOLD = I1

C --- shifting of contents, updating of physiological age
      DO 140 I1 = ILVOLD,1,-1
        LV(I1+1)    = LV(I1)
        SLA(I1+1)   = SLA(I1)
        LVAGE(I1+1) = LVAGE(I1)+FYSDEL*DELT
140   CONTINUE
      ILVOLD = ILVOLD+1

C --- new leaves in class 1
      LV(1)    = GRLV*DELT
      SLA(1)   = SLAT
      LVAGE(1) = 0.0 

C --- calculation of new leaf area and weight
      LASUM = 0.0
      WLV   = 0.0
      DO 150 I1 = 1,ILVOLD
        LASUM = LASUM+LV(I1)*SLA(I1)
        WLV   = WLV+LV(I1)
150   CONTINUE

C --- leaf area index in case of exponential growth
      LAIEXP = LAIEXP+GLAIEX*DELT

C --- dry weight of living plant organs
      WRT    = WRT+GWRT*DELT
      WST    = WST+GWST*DELT
      WSO    = WSO+GWSO*DELT

C --- total above ground biomass
      TADW   = WLV+WST+WSO

C --- dry weight of dead plant organs (roots,leaves & stems)
      DWRT   = DWRT+DRRT*DELT
      DWLV   = DWLV+DRLV*DELT
      DWST   = DWST+DRST*DELT

C --- dry weight of dead and living plant organs
C     TWRT   = WRT+DWRT
      TWLV   = WLV+DWLV
      TWST   = WST+DWST
      CWDM   = TWLV+TWST+WSO

C --- total gross assimilation and maintenance respiration
      GASST  = GASS + GASST
      MREST  = MRES + MREST

C --- leaf area index
      LAI    = LASUM+SSA*WST+SPA*WSO
C !!! LAIMAX is not used
      LAIMAX = MAX (LAI,LAIMAX)

C --- rooting depth
      RD     = RD+RR

C --- crop factor or crop height
      CF     = AFGEN (CFTAB,30,DVS)

C --- cumulative relative transpiration
      CPTR0 = CPTR0 + PTRA  
      CTR0  = CTR0  + TRA
      CRT0  = LIMITR8 (0.0D0,1.0D0,CTR0/CPTR0)

      IF (DVS.GE.1.0D0) THEN
        CPTR1 = CPTR1+PTRA
        CTR1  = CTR1 + TRA
        CRT1  = LIMITR8 (0.0D0,1.0D0,CTR1/CPTR1)
      ELSE
        CRT1 = 1.0d0
      ENDIF

C --- save some results of potential run
      IF (IPORWL.EQ.1) THEN
        CPWDM(CRPNR,ID) = CWDM
        PWSO(CRPNR,ID)  = WSO
      ENDIF

C === CROP FINISH CONDITIONS 

      IF (DVS.GE.DVSEND)                    IFINCR=1
      IF (YEAR.EQ.ECRPY.AND.DAYNR.EQ.ECRPD) IFINCR=2
      IF (LAI.LE.0.002D0.AND.DVS.GT.0.5D0)  IFINCR=3

      RETURN

3000  CONTINUE

C --- OUTPUT SECTION 

C --- open output file
      IF (FLOUT .OR. IFINCR.GT.0) THEN
        IF (.not.HDONE) then
          if (sw1fil.eq.0 .or. (sw1fil.eq.1.and. .not.sw1crp)) then
c           temporary solution to suppress file-opening
            sw1crp = .true.
            filnam = trim(envstr)//trim(outnam)//'.CR'//EXT(CRPNR)
            crp = getun (20,30)
            call fopens(crp,filnam,'new','del')
C --        write header
            WRITE (CRP,2010)
2010        FORMAT (
     &    '*DATE       DAY ID DVS  LAI  CF/H  RD  CRT0 CRT1 CPWDM CWDM'
     &    ,'  CPWSO CWSO *',/,
     &   '*dd/mm/yyyy  nr              -/cm  cm            kg/ha kg/ha '
     &   ,'kg/ha kg/ha*',/,
     &   '*<============><==><===><===><====><==><===><===><====><====>'
     &   ,'<====><====>')
            HDONE=.TRUE.
          endif
        endif

C ---   Write output

C ---   conversion of daynumber to date
        CALL NRTODA (YEAR,DAYNR,M,D)

C ---   write output record
        WRITE (CRP,2110) D,M,YEAR,NINT(T),ID,DVS,LAI,CF,
     &     NINT(RD),CRT0,CRT1,NINT(CPWDM(CRPNR,ID)),NINT(CWDM),
     &     NINT(PWSO(CRPNR,ID)),NINT(WSO)
2110    FORMAT (I3,'/',I2.2,'/',2I4,I4,2F5.2,F6.1,I4,2F5.2,4I6)

	ENDIF

C --- close output file
      if (sw1fil.eq.0 .and. ifincr.gt.0) then
        close (crp)
      endif

      RETURN
      END

C ----------------------------------------------------------------------
      SUBROUTINE GRASS (ITASK,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &  CRPNR,CRPFIL,OUTNAM,ECRPY,ECRPD,RDS,RAD,TAV,TAVD,TMNR,TRA,PTRA,
     &  RELTR,KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,ECMAX,ECSLOP,
     &  COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &  RDCTAB,RDM,LOGF,T,SWCF,CF,sw1fil,sw1crp)
C ----------------------------------------------------------------------
C     Date               : 09/10/97
C     Purpose            : grass growth routine for SWAP          
C     Subroutines called : RDCRP,SHIFTR,SHIFTL,NRTODA,ASTRO,TOTASS
C     Functions called   : AFGEN,LIMITR8
C     File usage         : OUTNAM.CR#, file with crop production results
C ----------------------------------------------------------------------
      IMPLICIT NONE  

      INTEGER   CRP,CRPNR,DAYNR,YEAR,M,D,ECRPY,ECRPD,LOGF,SWCF,sw1fil
      INTEGER   I1,ID,IDELAY,IDREGR,IFINCR,ILVOLD,IPORWL,ITASK,bayry
      integer*4 getun

      REAL*8    LAT,KDIF,LAI,LAICR,LAIEM,LAIEXP,LAIMAX,LASUM,LIMITR8
      REAL*8    MRES, LV(366),LVAGE(366),SLA(366),CPWDM(366),CPWHM(366)
      REAL*8    SLATB(30),AMAXTB(30),TMPFTB(30),TMNFTB(30)
      REAL*8    RFSETB(30),FRTB(30),FLTB(30),FSTB(30),RDRRTB(30)
      REAL*8    RDRSTB(30),HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L
      REAL*8    HLIM4,RDCTAB(22),ECMAX,ECSLOP,KDIR,COFAB,T,CF
C     REAL*8    LAITB(30),TWRT
      REAL*8    ADCRH,ADCRL,ADMI,AFGEN,AMAX,ASRC
      REAL*8    CCHECK,COSLD,CPTR0,CRT0,CTR0,CVF,CVL
      REAL*8    CVR,CVS,DALV,DAYL,DAYLP,DELT,DMI,DRLV
      REAL*8    DRRT,DRST,DRST1,DRST2,DSLV,DSLV1,DSLV2,DSLVT,DTEFF,DTGA
      REAL*8    DWLV,DWRT,DWST,FCHECK,FL,FR,FS,EFF
      REAL*8    FYSDEL,GASS,GLA,GLAIEX,GLASOL,GRLV,GRRT,GRST
      REAL*8    GWRT,GWST,PERDL,PGASS,PTRA,Q10,RAD,RD,RDC
      REAL*8    RDI,RDM,RDS,RELTR,REST,RGRLAI,RID,RML,RMR,RMRES,RMS,RR
      REAL*8    RRI,SINLD,SLAT,SPAN,SSA,TAGP,TAGPS,TAGPT,RSC
      REAL*8    TAV,TAVD,TBASE,TDWI,TEFF,TMNR,TRA,TWLV,TWST,WLV,WRT,WST

      CHARACTER CRPFIL*16,OUTNAM*16,FILNAM*80,ENVSTR*50
      CHARACTER EXT(3)

      LOGICAL   HDONE,FLOUT,sw1crp
  
      SAVE

      PARAMETER (DELT=1.0d0)

c     DATA LAITB/0.0,1.5,1000.0,0.84,2500.0,0.84,4000.0,0.84,
c    &           6000.0,0.6,8000.0,0.3,18*0.0/
C --- LAI of the stubble depends on biomass of preceeding harvest
C --- De Jong and Kabat, Lantinga

      DATA EXT/'1','2','3'/
C ----------------------------------------------------------------------
      GOTO (1000,2000,3000) ITASK

1000  CONTINUE

C --- INITIALIZATION ---------------------------------------------------

C --- read crop data
      CALL RDGRASS (CRPFIL,ENVSTR,TDWI,LAIEM,RGRLAI,SLATB,
     &  SSA,SPAN,TBASE,KDIF,KDIR,EFF,AMAXTB,TMPFTB,TMNFTB,CVL,CVR,CVS,
     &  Q10,RML,RMR,RMS,RFSETB,FRTB,FLTB,FSTB,PERDL,RDRRTB,
     &  RDRSTB,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &  ADCRH,ADCRL,ECMAX,ECSLOP,COFAB,RDI,RRI,RDC,RDCTAB,LOGF)

C --- maximum rooting depth & actual rooting depth
      RDM = MAX (RDI,MIN(RDS,RDC))
      RD  = RDI

C --- initial values of crop parameters
      RID      = DFloat (ID)
      FR       = AFGEN (FRTB,30,RID)
      FL       = AFGEN (FLTB,30,RID)
      FS       = AFGEN (FSTB,30,RID)
      SLA(1)   = AFGEN (SLATB,30,RID)
      LVAGE(1) = 0.
      ILVOLD   = 1
      IDREGR   = 0

C --- initial state variables of the crop

      WRT    = FR*TDWI
      WST    = FS*(1.0d0-FR)*TDWI 
      WLV    = LAIEM/SLA(1)
      LV(1)  = WLV
      LASUM  = LAIEM     
      LAIEXP = LAIEM     
      LAIMAX = LAIEM
      LAI    = LASUM+SSA*WST 
      DWRT   = 0.
      DWLV   = 0.
      DWST   = 0.
      CF     = 1.0d0 

C --- initial summation variables of the crop
      TAGP   = WLV+WST
      CPTR0  = 0.0
      CTR0   = 0.0
      TAGPT  = 0.0

C --- misc.
      SWCF   = 1
      IFINCR = 0
      IF (IPORWL.EQ.2) HDONE =.FALSE.

      RETURN

2000  CONTINUE

C --- RATES OF CHANGE OF THE CROP VARIABLES ----------------------------

      RID = DFLOAT(ID)

C !!! skip in case of regrowth
      IF (ID.NE.0.AND.ID.LT.IDREGR) GOTO 1330

C === DAILY DRY MATTER PRODUCTION 

C --- Gross assimilation
      AMAX  = AFGEN (AMAXTB,30,RID)
C --- correction for sub-optimum average daytemperature
      AMAX  = AMAX * AFGEN (TMPFTB,30,TAVD)
      CALL ASTRO (DAYNR,LAT,DAYL,DAYLP,SINLD,COSLD)
      CALL TOTASS (DAYNR,DAYL,AMAX,EFF,LAI,KDIF,RAD,SINLD,COSLD,DTGA)
C --- correction for low minimum temperature
      DTGA  = DTGA * AFGEN (TMNFTB,30,TMNR)
C --- potential assimilation in kg CH2O per ha
      PGASS = DTGA * 30./44.

C --- Water stress reduction of PGASS to GASS

      RELTR = LIMITR8 (0.0d0,1.0d0,TRA/PTRA)
      GASS  = PGASS * RELTR

C --- respiration and partitioning of carbohydrates between growth and
C --- maintenance respiration
      RMRES = (RMR*WRT+RML*WLV+RMS*WST)*AFGEN(RFSETB,30,RID)
      TEFF  = Q10**((TAV-25.0d0)/10.0)
      MRES  = MIN (GASS,RMRES*TEFF)
      ASRC  = GASS-MRES

C --- partitioning factors
      FR = AFGEN(FRTB,30,RID)
      FL = AFGEN(FLTB,30,RID)
      FS = AFGEN(FSTB,30,RID)
C --- check on partitioning
      FCHECK = FR+(FL+FS)*(1.0d0-FR) - 1.0d0
      IF (ABS(FCHECK).GT.0.0001d0) STOP 'Partitioning error'

C --- dry matter increase
      CVF   = 1.0/((FL/CVL+FS/CVS)*(1.0d0-FR)+FR/CVR)
      DMI   = CVF*ASRC
C --- check on carbon balance
      CCHECK = (GASS-MRES-(FR+(FL+FS)*(1.0d0-FR))*DMI/CVF)
     &         /MAX(0.0001d0,GASS)      
      IF (ABS (CCHECK).GT.0.0001d0) STOP 'Carbon balance error'

C === GROWTH RATE BY PLANT ORGAN 

C --- root length
      RR = MIN (RDM-RD,RRI)
      IF (FR.LE.0.OR.PGASS.LT.1.0d0) RR = 0.0

C --- growth rate roots and aerial parts
C --- after reaching a live weight of 2500 kg, the growth
C --- of the roots is balanced by the death of root tissue
      GRRT = FR*DMI
      IF (WRT.GT.2500.0d0) GRRT = 0.0
      ADMI = (1.0d0-FR)*DMI
      DRRT = 0.0
      GWRT = GRRT-DRRT

C --- Growth rate leaves

C --- weight of new leaves
      GRLV = FL*ADMI

C --- death of leaves due to water stress or high LAI
      DSLV1 = WLV*(1.0d0-TRA/PTRA)*PERDL
      LAICR = 3.2/KDIF
      DSLV2 = WLV*LIMITR8(0.0d0,0.03d0,0.03*(LAI-LAICR)/LAICR)
      DSLV  = MAX (DSLV1,DSLV2) 

C --- death of leaves due to exceeding life span;
C --- leaf death is imposed on array until no more leaves have
C --- to die or all leaves are gone

      REST = DSLV*DELT
      I1   = ILVOLD

100   IF (REST.GT.LV(I1).AND.I1.GE.1) THEN
        REST = REST-LV(I1) 
        I1   = I1-1
        GOTO 100
      ENDIF

C --- check if some of the remaining leaves are older than SPAN,
C --- sum their weights

      DALV = 0.0
      IF (LVAGE(I1).GT.SPAN.AND.REST.GT.0.AND.I1.GE.1) THEN
        DALV = LV(I1)-REST
        REST = 0.0
        I1   = I1-1
      ENDIF

110   IF (I1.GE.1.AND.LVAGE(I1).GT.SPAN) THEN
        DALV = DALV+LV(I1)
        I1   = I1-1
      GOTO 110
      ENDIF

      DALV = DALV/DELT

C --- death rate leaves and growth rate living leaves
      DRLV = DSLV+DALV

C --- physiologic ageing of leaves per time step
      FYSDEL = MAX (0.0d0,(TAV-TBASE)/(35.0d0-TBASE))
      SLAT   = AFGEN (SLATB,30,RID)

C --- leaf area not to exceed exponential growth curve
      IF (LAIEXP.LT.6.0d0) THEN
        DTEFF  = MAX (0.0d0,TAV-TBASE)
        GLAIEX = LAIEXP*RGRLAI*DTEFF
C --- source-limited increase in leaf area
        GLASOL = GRLV*SLAT
        GLA    = MIN (GLAIEX,GLASOL)
C --- adjustment of specific leaf area of youngest leaf class
        IF (GRLV.GT.0.0) SLAT = GLA/GRLV
      ENDIF  

C --- growth rate stems
      GRST = FS*ADMI
C --- death of stems due to water stress
      DRST1 = WST*(1.0d0-TRA/PTRA)*PERDL
C --- death of stems due to ageing
      DRST2 = AFGEN (RDRSTB,30,RID)*WST
      DRST = (DRST1+DRST2)/DELT 
      GWST = GRST-DRST

C ----INTEGRALS OF THE CROP --------------------------------------------

************************************************************************
*     After cutting, growth is initialized again. The weight of 
*     the sward is stored.
************************************************************************

C --- Harvest criteria (open to personal choice of user) 
      IF (TAGP.GT.4200.0d0 .OR. (ID.GT.210 .AND. TAGP.GT.3700.0d0)) THEN

*       when using relation LAITB according to literature:
*       LASUM    = AFGEN (LAITB,30,TAGP)
*       else:  
        LASUM    = LAIEM
        SLA(1)   = AFGEN (SLATB,30,RID)
        WLV      = LASUM/SLA(1)
        FL       = AFGEN (FLTB,30,RID)
        FS       = AFGEN (FSTB,30,RID)
        WST      = FS/FL*WLV
        DWLV     = 0.0
        DWST     = 0.0
        LVAGE(1) = 0.0
        ILVOLD   = 1
        LAIEXP   = LASUM
        LV(1)    = WLV

c       GWLV = 0.0
        GWST = 0.0
        GWRT = 0.0
        DRLV = 0.0
        DRST = 0.0
        DRRT = 0.0

        TAGPS = MAX (0.0D0,(TAGP-(WLV+DWLV+WST+DWST)))
        TAGPT = TAGPT + TAGPS

C --- regrowth delay after handbook P.R.

        IF (TAGPS.LT.2000.0d0) IDELAY = 1
        IF (TAGPS.GE.2000.0d0.AND.TAGPS.LT.2500.0d0) IDELAY = 2
        IF (TAGPS.GE.2500.0d0.AND.TAGPS.LT.3000.0d0) IDELAY = 3
        IF (TAGPS.GE.3000.0d0.AND.TAGPS.LT.3500.0d0) IDELAY = 4
        IF (TAGPS.GE.3500.0d0.AND.TAGPS.LT.4000.0d0) IDELAY = 5
        IF (TAGPS.GE.4000.0d0) IDELAY = 6

        IDREGR = ID+IDELAY+1

      ENDIF

      IF (ID.LT.IDREGR) GOTO 1330

C --- leaf death is imposed on array untill no more leaves have to
C --- die or all leaves are gone

      DSLVT = DSLV*DELT
      I1    = ILVOLD
120   IF (DSLVT.GT.0.AND.I1.GE.1) THEN
        IF (DSLVT.GE.LV(I1)) THEN
          DSLVT  = DSLVT-LV(I1)
          LV(I1) = 0.0
          I1     = I1-1
        ELSE
          LV(I1) = LV(I1)-DSLVT
          DSLVT  = 0.0
        ENDIF
      GOTO 120
      ENDIF 

130   IF (LVAGE(I1).GE.SPAN.AND.I1.GE.1) THEN
        LV(I1) = 0.0
        I1     = I1-1
      GOTO 130
      ENDIF

      ILVOLD = I1

C --- shifting of contents, integration of physiological age
      DO 140 I1 = ILVOLD,1,-1
        LV(I1+1)    = LV(I1)
        SLA(I1+1)   = SLA(I1)
        LVAGE(I1+1) = LVAGE(I1)+FYSDEL*DELT
140   CONTINUE
      ILVOLD = ILVOLD+1

C --- new leaves in class 1
      LV(1)    = GRLV*DELT
      SLA(1)   = SLAT
      LVAGE(1) = 0. 

C --- calculation of new leaf area and weight
      LASUM = 0.
      WLV   = 0.
      DO 150 I1 = 1,ILVOLD
        LASUM = LASUM+LV(I1)*SLA(I1)
        WLV   = WLV+LV(I1)
150   CONTINUE

      LAIEXP = LAIEXP+GLAIEX*DELT

1330  CONTINUE

C --- dry weight of living plant organs
      WRT    = WRT+GWRT*DELT
      WST    = WST+GWST*DELT

C --- dry weight of dead plant organs (roots,leaves & stems)
      DWRT   = DWRT+DRRT*DELT
      DWLV   = DWLV+DRLV*DELT
      DWST   = DWST+DRST*DELT

C --- dry weight of dead and living plant organs
c     TWRT   = WRT+DWRT
      TWLV   = WLV+DWLV
      TWST   = WST+DWST
      TAGP   = TWLV+TWST

C --- leaf area index
      LAI    = LASUM+SSA*WST
      LAIMAX = MAX (LAI,LAIMAX)

C --- rooting depth
      RD     = RD+RR

C --- cumulative relative transpiration
      CPTR0 = CPTR0 + PTRA  
      CTR0  = CTR0  + TRA
      CRT0  = LIMITR8 (0.0d0,1.0d0,CTR0/CPTR0)

C --- save some results of potential run
      IF (IPORWL.EQ.1) THEN
        CPWDM(ID) = TAGP
        CPWHM(ID) = TAGPT
      ENDIF

C === CROP FINISH CONDITIONS 

      IF (YEAR.EQ.ECRPY.AND.DAYNR.EQ.ECRPD) IFINCR=2

      RETURN

3000  CONTINUE

C --- OUTPUT SECTION 

C --- open output file
      IF (FLOUT .OR. (IFINCR.GT.0)) THEN
        IF (.not.HDONE) then
          if (sw1fil.eq.0 .or. (sw1fil.eq.1.and. .not.sw1crp)) then
c           temporary solution to suppress file-opening
            sw1crp = .true.
            filnam = trim(envstr)//trim(outnam)//'.CR'//EXT(CRPNR)
            crp = getun (20,30)
            call fopens(crp,filnam,'new','del')
C --       write header
            WRITE (CRP,2010)
2010        FORMAT (
     &    '*DATE       DAY ID LAI  RD  CRT0 PSTDM STDM  PHADM HADM *',/,
     &    '*dd/mm/yyyy  nr         cm       kg/ha kg/ha kg/ha kg/ha*',/,
     &    '*<============><==><===><==><===><====><====><====><====>')
            HDONE=.TRUE.
          endif
        endif

C ---   Write output

C ---   conversion of daynumber to date
        CALL NRTODA (YEAR,DAYNR,M,D)

C ---   write output record
        WRITE (CRP,2110) D,M,YEAR,NINT(T),ID,LAI,NINT(RD),CRT0,
     &    NINT(CPWDM(ID)),NINT(TAGP),NINT(CPWHM(ID)),NINT(TAGPT)
2110    FORMAT (I3,'/',I2.2,'/',2I4,I4,F5.2,I4,F5.2,4I6)

	ENDIF

C --- close output file
      if (sw1fil.eq.0 .and. ifincr.gt.0) then
        close (crp)
      endif

      RETURN
      END

C ----------------------------------------------------------------------
      SUBROUTINE CROPS (ITASK,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     & CRPNR,CRPFIL,OUTNAM,ECRPY,ECRPD,RDS,TAV,TRA,PTRA,RELTR,KDIF,KDIR,
     & LAI,RD,IFINCR,ADCRH,ADCRL,DVS,HLIM1,HLIM2U,HLIM2L,HLIM3H,
     & HLIM3L,HLIM4,RSC,RDCTB,RDM,ECMAX,ECSLOP,COFAB,LOGF,SWGC,GC,
     & SWCF,CF,T,IDEV,sw1fil,sw1crp)
C ----------------------------------------------------------------------
C     Date               : 21/1/99                           
C     Purpose            : simple crop growth routine for SWAP 
C     Subroutines called : RDCRPS,SHIFTR,SHIFTL,NRTODA
C     Functions called   : AFGEN,LIMITR8,STEPNR
C     File usage         : OUTNAM.CR#, file with crop growth results
C ----------------------------------------------------------------------
      IMPLICIT NONE

      INTEGER   CRP,CRPNR,DAYNR,YEAR,M,D,ECRPY,ECRPD,STEPNR,SWGC,sw1fil
      INTEGER   I,ICGS,ID,IDEV,IFINCR,IPORWL,ITASK,LCC,LOGF,SWCF,bayry
      integer*4 getun,crpout

      REAL*8    GCTB(72),CFTB(72),RDTB(72),KYTB(72),LIMITR8,LAI,T
      REAL*8    CPTR(36),CTR(36),CRT(36),RELY(36),HELP(36),RDCTB(22)
      REAL*8    ADCRH,ADCRL,AFGEN,CPTR0,CRELY,CRT0,CTR0,DTSUM,DVR,DVS
      REAL*8    ECMAX,ECSLOP,PTRA,RD,RDS,RELTR,TAV,TBASE,TRA,TSUMAM
      REAL*8    HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RDM,TSUMEA
      REAL*8    KDIF,KDIR,COFAB,RSC,GC,CF

      CHARACTER CRPFIL*16,OUTNAM*16,FILNAM*80,ENVSTR*50
      CHARACTER EXT(3)

      LOGICAL   FLOUT,HDONE,sw1crp

      SAVE

      DATA EXT/'1','2','3'/
C ----------------------------------------------------------------------
      GOTO (1000,2000,3000) ITASK

1000  CONTINUE

C --- INITIALIZATION ---------------------------------------------------

C --- read crop data
      CALL RDCRPS (CRPFIL,ENVSTR,IDEV,LCC,TSUMEA,TSUMAM,TBASE,
     & KDIF,KDIR,GCTB,SWGC,CFTB,SWCF,RDTB,KYTB,HLIM1,HLIM2U,HLIM2L,
     & HLIM3H,HLIM3L,HLIM4,RSC,ADCRH,ADCRL,ECMAX,ECSLOP,RDCTB,
     & COFAB,LOGF)

C --- development stage
      DVS = 0.0

C --- initial LAI or SC
      LAI = AFGEN (GCTB,72,DVS)
      If (SWGC.EQ.2) then
        GC  = LAI
        LAI = LAI*3
      Endif

C --- initial crop factor or crop height
      CF  = AFGEN (CFTB,72,DVS)

C --- maximum rooting depth & actual rooting depth [cm]
      RDM = 0.0
      DO 2 I = 1,36
        IF (RDM.LT.RDTB(I*2)) RDM = RDTB(I*2)
    2 continue
      RDM = MIN (RDS,RDM)       
      RD  = MIN (RDM,AFGEN (RDTB,72,DVS))

C --- initial summation variables of the crop
      CPTR0 = 0.
      CTR0  = 0.

C --- init arrays with cum. pot. and act. transpiration 
      DO 4 I = 1,36
        CPTR(I) = 0.0
        CTR(I)  = 0.0
4     CONTINUE

C --- misc.
      IFINCR = 0
      IF (IPORWL.EQ.2) HDONE  = .FALSE.

      RETURN          

2000  CONTINUE

C --- RATES OF CHANGE OF THE CROP VARIABLES ----------------------------

C --- increase in temperature sum
      DTSUM = MAX (0.0d0,TAV-TBASE)

C --- development rate
      IF (IDEV.EQ.1) THEN
        DVR = 2.0/LCC
      ELSEIF (IDEV.EQ.2) THEN
        IF (DVS.LT.1.0d0) THEN
          DVR = DTSUM/TSUMEA
        ELSE
          DVR = DTSUM/TSUMAM
        ENDIF
      ENDIF

C --- determination of current growing stage
      DO 6 I = 1,36
        HELP(I) = KYTB(2*I-1)
    6 continue
      ICGS = STEPNR (HELP,36,DVS)

C --- Water stress
      RELTR = LIMITR8 (0.0d0,1.0d0,TRA/PTRA)

C ----INTEGRALS OF THE CROP --------------------------------------------

C --- phenological development stage
      DVS = DVS+DVR

C --- leaf area index or soil cover fraction    
      LAI = AFGEN (GCTB,72,DVS)
      If (SWGC.EQ.2) then
        GC  = LAI
        LAI = LAI*3
      Endif

C --- crop factor or crop height
      CF = AFGEN (CFTB,72,DVS)

C --- rooting depth [cm]
      RD = MIN (RDM,AFGEN (RDTB,72,DVS))

C --- cumulative relative transpiration, total growing season 
      CPTR0 = CPTR0 + PTRA  
      CTR0  = CTR0  + TRA
      CRT0  = LIMITR8 (0.0d0,1.0d0,CTR0/CPTR0)

C --- cumulative relative transpiration, current growing stage
      CPTR(ICGS) = CPTR(ICGS) + PTRA
      CTR(ICGS)  = CTR(ICGS)  + TRA
      CRT(ICGS)  = LIMITR8 (0.0d0,1.0d0,CTR(ICGS)/CPTR(ICGS)) 

C --- relative yield per growing stage and cumulated
      CRELY = 1.0d0 
      DO 8 I = 1,ICGS
        RELY(I) = 1.0d0-((1.0d0-CRT(I))*KYTB(2*I))
        CRELY   = CRELY*RELY(I)
8     CONTINUE

C --- crop finish conditions                       
      IF (DVS.GE.2.0d0)                     IFINCR = 1 
      IF (YEAR.EQ.ECRPY.AND.DAYNR.EQ.ECRPD) IFINCR = 2 

      RETURN

3000  CONTINUE

C --- OUTPUT SECTION 

C --- open output file
      IF (FLOUT .OR. (IFINCR.GT.0)) THEN
        IF (.not.HDONE) then
          if (sw1fil.eq.0 .or. (sw1fil.eq.1.and. .not.sw1crp)) then
c           temporary solution to suppress file-opening
            sw1crp = .true.
            filnam = trim(envstr)//trim(outnam)//'.CR'//EXT(CRPNR)
            crp = getun (20,30)
            call fopens(crp,filnam,'new','del')
C --        write header
            WRITE (CRP,100)
100         FORMAT (
     $       '*DATE       DAY ID DVS  LAI  CF/H  RD  CRT  RELY*',/,
     $       '*dd/mm/yyyy  nr              -/cm  cm           *',/,
     $       '*<============><==><===><===><====><==><===><===>')
            HDONE = .TRUE.
          endif
        endif

C ---   Write output

C ---   conversion of daynumber to date
        CALL NRTODA (YEAR,DAYNR,M,D)

C --- write output record
        WRITE (CRP,200) D,M,YEAR,NINT(T),ID,DVS,LAI,CF,NINT(RD),
     &   CRT0,CRELY
200     FORMAT (I3,'/',I2.2,'/',2I4,I4,2F5.2,F6.1,I4,2F5.2)

	ENDIF

C --- close output file
      if (sw1fil.eq.0 .and. ifincr.gt.0) then
        close (crp)
      endif

      RETURN
      END

C ----------------------------------------------------------------------
      SUBROUTINE IRRIG (TASK,ENVSTR,IRGNAM,OUTNAM,IRMODE,YEAR,
     & DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,GIRD,ISUA,CIRR,
     & NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,HTABLE,THETLO,
     & H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     & CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY,sw1fil)
C ----------------------------------------------------------------------
C     Date               : 6/6/2001        
C     Purpose            : evaluate and schedule irrigations
C     Subroutines called : SHIFTR,SHIFTL,DATONR,NRTODA
C     Functions called   : STEPNR,THENODE
C     File usage         : IRGNAM.IRG, historical irrigations 
C                        : IRGNAM.CAP, timing and depth criteria
C                        : OUTNAM.SCH, scheduled irrigations
C ----------------------------------------------------------------------
      IMPLICIT NONE
      Include 'Param.fi'

C --- global
      INTEGER   TASK,YEAR,DAYNR,ID,NUMNOD,LAYER(MACP),sw1fil
      INTEGER   THETLO(MAHO),ISUA,CRPNR,RUNNR,LOGF,FMAY,BAYRY

      REAL*8    DZ(MACP),DISNOD(MACP+1),DRZ,RELTR,DVS,GIRD,CIRR
      REAL*8    HLIM3H,HLIM3L,HLIM4

      REAL*8    H(MACP),COFGEN(8,MAHO),HTABLE(MAHO,99)
      REAL*8    THETAS(MACP),THETAR(MACP),ALFAMG(MACP)

      CHARACTER ENVSTR*50,IRGNAM*16,OUTNAM*16
      CHARACTER*16 CAPFIL(3,MAYRS)

      LOGICAL   FLIRGE,FLIRGS,FLGENU(MAHO)
C ----------------------------------------------------------------------
C --- local
      INTEGER   NOFPIR,IRG,CAP,SCH,M,D,NR,IIRDAT(3,MAIRG)
      INTEGER   TCS1,TCS2,TCS3,TCS4,TCS5,PHORMC,DCS1,DCS2,STEPNR
      INTEGER   ISUAS,NODE,NODDRZ,NODSEN,IEVENT,IDELTR,I,IRMODE
      INTEGER   IFND,SUA(MAIRG),dd(MAIRG),mm(MAIRG),yy(MAIRG)
      Integer   BeginYe,EndYe,BeginMo,EndMo,dayIrg,MonthIrg,YearIrg
      Integer   IFirst
      integer*4 getun2, getun, datea(6)
      real*4    fsec

      REAL*8    TPS1X(7),TPS2X(7),TPS3X(7),TPS4X(7),TPS5X(7)
      REAL*8    TPS1Y(7),TPS2Y(7),TPS3Y(7),TPS4Y(7),TPS5Y(7)
      REAL*8    DPS1X(7),DPS2X(7),DPS1Y(7),DPS2Y(7),RIRDAT(2,MAIRG)
      REAL*8    CIRRS,DEP,FRLOW,PHLO,PHHI,PHME,AWLH,AWMH,AWAH,CDEF
      REAL*8    WCLO,WCME,WCHI,WCAC,TPS1,TPS2,TPS3,TPS4,TPS5,DEPL,PHCRIT
      REAL*8    DCRIT,DPS1,DPS2
      REAL*8    depth(MAIRG),Conc(MAIRG),date_irg(mairg)
      REAL*8    THENODE,PRHNODE

      CHARACTER FILNAM*80,LINE*80,MonthStr*3
      CHARACTER EXT(3)

      LOGICAL   EXISTS,HDONE,BLANK,COMMENT

      SAVE

      DATA EXT/'1','2','3'/
C ----------------------------------------------------------------------
      GOTO (1000,2000,3000,4000) TASK

1000  CONTINUE

C --- INITIALIZATION part one ------------------------------------------

C --- Read file with irrigation gifts

C --- compose filename
      filnam = trim(envstr)//trim(irgnam)//'.irg'

C --- check if a file with fixed irrigation data has been specified
      IF (len_trim(irgnam).lt.1) THEN
        FLIRGE = .FALSE.
	ELSE
        FLIRGE = .TRUE.
	ENDIF

      IF (FLIRGE) THEN

C ---   read irrigation gifts and store in IRGDAT

C ---   initialise and start reading
        nofpir = 0
        irg = getun2 (10,19,2)
        call rdinit(irg,logf,filnam)

        If (sw1fil.EQ.0) then
C ---     data from files for each subrun/year
          call rdainr ('dd_irg',1,31,dd,mairg,ifnd)
          call rdfinr ('mm_irg',1,12,mm,mairg,ifnd)
          call rdfdor ('depth',0.0d0,1000.0d0,depth,mairg,ifnd)
          call rdfdor ('conc',0.0d0,1000.0d0,conc,mairg,ifnd)
          call rdfinr ('sua',0,1,sua,mairg,ifnd)

        elseif (sw1fil.EQ.1) then 
C ---     data from one file
          call rdatim ('date_irg',date_irg,mairg,ifnd)
          call rdfdor ('depth',0.0d0,1000.0d0,depth,mairg,ifnd)
          call rdfdor ('conc',0.0d0,1000.0d0,conc,mairg,ifnd)
          call rdfinr ('sua',0,1,sua,mairg,ifnd)
          do i = 1,ifnd
            call dtdpar(date_irg(i),datea,fsec)
            yy(i) = datea(1)
            mm(i) = datea(2)
            dd(i) = datea(3)
          enddo
        endif
        CLOSE (IRG)

        if (sw1fil.EQ.0) then
C ---     year is calculated
          DO 22 I = 1,IFND
            IF (mm(I).GE.FMAY) yy(I) = BAYRY
            IF (mm(I).LT.FMAY) yy(I) = BAYRY+1
22        CONTINUE
        endif

        Do 44 I= 1,IFND
          CALL DATONR (YY(I),MM(I),DD(I),NR)
          IIRDAT(1,I) = YY(I)
          IIRDAT(2,I) = NR
          RIRDAT(1,I) = depth(I)
          RIRDAT(2,I) = conc(I)
          IIRDAT(3,I) = sua(I)
44      CONTINUE
        NOFPIR = IFND

      ENDIF

      RETURN

C --- READ IRRIGATION CRITERIA (TIMING & DEPTH) - scheduling phase

2000  CONTINUE

C --- compose filename
      filnam = trim(envstr)//trim(capfil(crpnr,runnr))//'.cap'

C --- check if a file with irrigation scheduling criteria has been specified
      IF (len_trim(capfil(crpnr,runnr)).lt.1) THEN
        FLIRGS = .FALSE.
	ELSE
        FLIRGS = .TRUE.
	ENDIF

      IF (FLIRGS) THEN

C ---   read application method & timing and depth criteria
        cap = getun2 (10,19,2)
        call rdinit(cap,logf,filnam)
C ---   application method
        call rdsinr ('isuas',0,1,isuas)
C ---   solute concentration irrigation water
        call rdsdor ('cirrs',0.0d0,100.0d0,cirrs)

C ===   TIMING criteria

C -1-   Timing - allowable daily stress
        call rdsinr ('tcs1',0,1,tcs1)
        IF (TCS1.EQ.1) THEN
          call rdador('dvs_tc1',-0.0d0,2.0d0,tps1x,7,ifnd)
          call rdfdor('Trel',0.0d0,1.0d0,tps1y,7,ifnd)
        ENDIF

C -2-   Timing - depletion of readily available water
        call rdsinr ('tcs2',0,1,tcs2)
        IF (TCS2.EQ.1) THEN
          call rdador('dvs_tc2',-0.0d0,2.0d0,tps2x,7,ifnd)
          call rdfdor('raw',0.0d0,1.0d0,tps2y,7,ifnd)
        ENDIF
C ---   ready...

C -3-   Timing - depletion of totally available water
        call rdsinr ('tcs3',0,1,tcs3)
        IF (TCS3.EQ.1) THEN
          call rdador('dvs_tc3',-0.0d0,2.0d0,tps3x,7,ifnd)
          call rdfdor('taw',0.0d0,1.0d0,tps3y,7,ifnd)
        ENDIF
C ---   ready...

C -4-   Timing - allowable depletion amount            
        call rdsinr ('tcs4',0,1,tcs4)
        IF (TCS4.EQ.1) THEN
          call rdador('dvs_tc4',-0.0d0,2.0d0,tps4x,7,ifnd)
          call rdfdor('dwa',0.0d0,500.0d0,tps4y,7,ifnd)
        ENDIF
C ---   ready...

C -5-   Timing - critical press. head or moist. content at sensor depth
        call rdsinr ('tcs5',0,1,tcs5)
        IF (TCS5.EQ.1) THEN
          call rdsinr ('phormc',0,1,phormc)
          call rdsdor ('dcrit',-100.0d0,0.0d0,dcrit)
          call rdador('dvs_tc5',-0.0d0,2.0d0,tps5x,7,ifnd)
          if (phormc.eq.0) then
            call rdfdor('value_tc5',-1.0d6,-100.0d0,tps5y,7,ifnd)
          else
            call rdfdor('value_tc5',0.0d0,1.0d0,tps5y,7,ifnd)
          endif
        ENDIF
C ---   ready...
        if (TCS1+TCS2+TCS3+TCS4+TCS5.gt.1) then
          write (*,*) 
     &    ' error with switches for timing criteria in file ',filnam
          stop
        endif


C ===   DEPTH criteria

C -1-   Depth - back to field capacity
        call rdsinr ('DCS1',0,1,dcs1)
        IF (DCS1.EQ.1) THEN
          call rdador('dvs_dc1',-0.0d0,2.0d0,dps1x,7,ifnd)
          call rdfdor('dI',-100.0d0,+100.0d0,dps1y,7,ifnd)
        ENDIF
C ---   ready...

C -2-   Depth - fixed depth
        call rdsinr ('DCS2',0,1,dcs2)
        IF (DCS2.EQ.1) THEN
          call rdador('dvs_dc2',-0.0d0,2.0d0,dps2x,7,ifnd)
          call rdfdor('dI',0.0d0,400.0d0,dps2y,7,ifnd)
        ENDIF
C ---   ready...

        CLOSE (CAP)

        if (DCS1+DCS2.gt.1) then
          write (*,*) 
     &    ' error with switches for depth criteria in file',filnam
          stop
        endif
      ENDIF

C --- miscellaneous
      HDONE = .FALSE.
      IDELTR = 1

      RETURN

3000  CONTINUE

C --- DRIVING VARIABLES ------------------------------------------------

C --- EVALUATION MODE - search for irrigation gift [cm]  

      IF (IRMODE.EQ.1.OR.IRMODE.EQ.2) THEN
        IEVENT = 0
        GIRD   = 0.0
        CIRR   = 0.0
        ISUA   = 0
        DO 84 I = 1,NOFPIR
          IF (YEAR.EQ.IIRDAT(1,I).AND.DAYNR.EQ.IIRDAT(2,I)) THEN
            GIRD = RIRDAT(1,I)/10.0
            CIRR = RIRDAT(2,I)
            ISUA = IIRDAT(3,I) 
            GOTO 88
          ENDIF
84      CONTINUE
88      CONTINUE
        IF (GIRD.GT.0.0) RETURN
      ENDIF

C --- SCHEDULING MODE - current timing and depth criterion

      IF (IRMODE.EQ.2) THEN
        IEVENT = 0
        GIRD   = 0.0
        CIRR   = CIRRS
        ISUA   = ISUAS

C ---   determine lowest compartment containing roots
        DEP = 0.0 
        DO 92 NODE = 1,NUMNOD
          NODDRZ = NODE
          DEP    = DEP - DZ(NODE)
          IF (DRZ.GE.DEP-1.0d-6) GOTO 96
92      CONTINUE
96      FRLOW = (DZ(NODDRZ)-(DRZ-DEP))/DZ(NODDRZ)

C ---   determine water holding capacity, readily available water, 
C ---   actual available water and water deficit
        PHLO = -100.0d0
        PHME = (HLIM3L+HLIM3H)/2
        PHHI = HLIM4
        AWLH = 0.0
        AWMH = 0.0
        AWAH = 0.0
        CDEF = 0.0
        DO 100 NODE = 1,NODDRZ
          WCLO = REAL(THENODE(NODE,DBLE(PHLO),LAYER,FLGENU,
     &           COFGEN,HTABLE,THETLO,ALFAMG,THETAR,THETAS))
     &           *DZ(NODE)
                 IF (NODE.EQ.NODDRZ) WCLO = WCLO*FRLOW
          WCME = REAL(THENODE(NODE,DBLE(PHME),LAYER,FLGENU,
     &           COFGEN,HTABLE,THETLO,ALFAMG,THETAR,THETAS))
     &           *DZ(NODE)
                 IF (NODE.EQ.NODDRZ) WCME = WCME*FRLOW
          WCHI = REAL(THENODE(NODE,DBLE(PHHI),LAYER,FLGENU,
     &           COFGEN,HTABLE,THETLO,ALFAMG,THETAR,THETAS))
     &           *DZ(NODE)
                 IF (NODE.EQ.NODDRZ) WCHI = WCHI*FRLOW
          WCAC = REAL(THENODE(NODE,H(NODE),LAYER,FLGENU,
     &           COFGEN,HTABLE,THETLO,ALFAMG,THETAR,THETAS))
     &           *DZ(NODE)
                 IF (NODE.EQ.NODDRZ) WCAC = WCAC*FRLOW
            
          AWLH = AWLH+(WCLO-WCHI)
          AWMH = AWMH+(WCME-WCHI)
          AWAH = AWAH+(WCAC-WCHI)
          CDEF = CDEF+(WCLO-WCAC) 
100     CONTINUE

C -1-   Timing - allowable daily stress
        IF (TCS1.EQ.1) THEN
          TPS1 = TPS1Y (STEPNR(TPS1X,7,DVS))
          IF ((RELTR.LT.TPS1).AND.(ID.GT.1).AND.(CDEF.GT.0)) IEVENT = 1
        ENDIF

C -2-   Timing - depletion of Readily Available Water (fraction)
        IF (TCS2.EQ.1) THEN
C ---     compare readily available water and actual available water
          TPS2 = TPS2Y (STEPNR(TPS2X,7,DVS))
          DEPL = TPS2*(AWLH-AWMH)
          IF (DEPL.GT.AWLH) DEPL=AWLH 
          IF (AWAH.LT.(AWLH-DEPL)) IEVENT=1
        ENDIF

C -3-   Timing - depletion of Totally Available Water (fraction)
        IF (TCS3.EQ.1) THEN
C ---     compare totally available water and actual available water
          TPS3 = TPS3Y (STEPNR(TPS3X,7,DVS))
          DEPL = TPS3*AWLH
          IF (AWAH.LT.(AWLH-DEPL)) IEVENT=1
        ENDIF

C -4-   Timing - allowable amount of depletion
        IF (TCS4.EQ.1) THEN
C ---     check if depletion amount has been exceeded                
          TPS4 = TPS4Y (STEPNR(TPS4X,7,DVS))/10.0
          IF ((AWLH-AWAH).GT.TPS4) IEVENT=1
        ENDIF

C -5-   Timing - critical pressure head or moisture content exceeded
        IF (TCS5.EQ.1) THEN
C ---     determine compartment number of sensor depth
          DEP = 0.0
          DO 110 NODE = 1,NUMNOD
            NODSEN = NODE
            DEP    = DEP - DZ(NODE)
            IF (-ABS(DCRIT).GE.DEP-1.0d-6) GOTO 114
110       CONTINUE

114       TPS5 = TPS5Y (STEPNR(TPS5X,7,DVS))
C ---     calculation of critical pressure head
          IF (PHORMC.EQ.0) THEN
            PHCRIT = -ABS(TPS5)
          ELSEIF (PHORMC.EQ.1) THEN
            PHCRIT = PRHNODE(NODSEN,DBLE(TPS5),LAYER,DISNOD,
     &               H,FLGENU,THETAR,THETAS,COFGEN,ALFAMG,HTABLE)
          ENDIF

C ---     compare critical pressure head and actual pressure head
          IF (H(NODSEN).LE.PHCRIT) IEVENT = 1
        ENDIF

C ---   Depth - back to field capacity [cm]
        IF ((IEVENT.EQ.1).AND.(DCS1.EQ.1)) THEN
C ---     correct for over- or under irrigation
          DPS1 = DPS1Y (STEPNR(DPS1X,7,DVS))
          GIRD = MAX (0.0d0,CDEF+DPS1/10.0) 
        ENDIF

C ---   Depth - fixed depth [cm]
        IF ((IEVENT.EQ.1).AND.(DCS2.EQ.1)) THEN
          DPS2 = DPS2Y (STEPNR(DPS2X,7,DVS))
          GIRD = DPS2/10.0
        ENDIF

      ENDIF

C --- OUTPUT SECTION ---------------------------------------------------

C --- triggering on two consecutive days is prohibited
      IDELTR = IDELTR+1
      IF (IEVENT.EQ.0) GOTO 2500
      IF (IDELTR.LE.3) THEN
        GIRD = 0.0
        GOTO 2500
      ELSE
        IDELTR = 0
      ENDIF

      GOTO (2500,2300) IRMODE 

C --- Write scheduled irrigations

2300  if (.not.hdone) then 

c ---   open output file
        filnam = trim(envstr)//trim(outnam)//'.sc'//ext(crpnr)
        sch = getun (20,30)
        call fopens(sch,filnam,'new','del')

c --- write header
        write (sch,2310)
2310    format (
     &  '*OUTNAM   DATE       ID DEPTH*',/,
     &  '*         dd/mm/yyyy    mm   *',/,
     &  '*<======><=============><====>')

        hdone = .true.
      endif

c --- write output

C --- conversion of daynumber to date
      CALL NRTODA (YEAR,DAYNR,M,D)

C --- write output record
      WRITE (SCH,'(A8,I3,''/'',I2.2,''/'',2I4,I6)') OUTNAM,D,M,YEAR,ID,
     &INT(GIRD*10) 

2500  RETURN

4000  CONTINUE
 
C --- TERMINAL SECTION -------------------------------------------------

C --- close output file scheduling phase
      CLOSE (SCH)

      RETURN
      END

C ----------------------------------------------------------------------
      SUBROUTINE METEO (T,DT,IPORWL,
     &  YEAR,DAYNR,WTHFIL,ENVSTR,LAT,ALT,KDIF,KDIR,LAI,GIRD,
     &  ISUA,RAD,TAV,TAVD,TMNR,RH,GRAI,NRAI,NIRD,ATMDEM,PTRA,PEVA,
     &  RAITIM,RAIFLX,FLRAI,ARFLUX,CFBS,RSC,SWETR,
     &  ISTAGE,ICRMOD,LOGF,SWSHF,FLRAIC,COFAB,FLRDME,SWGC,GC,SWRAI,
     &  IDEV,SWCF,CF,SWCFBS)
C ----------------------------------------------------------------------
C     Last modified      : 16/4/99              
C     Purpose            : returns daily values for the variables:
C                          solar radiation         := J/m2,
C                          average temperature     := C,
C                          average day temperature := C,
C                          7 day running av. min t := C,
C                          vapour pressure deficit := mbar
C                          relative humidity       := fraction,
C                          gross rainfall          := cm,
C                          net rainfall            := cm,
C                          net irr. depth          := cm,
C                          atmospheric demand      := cm,
C                          potential evaporation   := cm;
C                          potential transpiration := cm,
C     Subroutines called : SHIFTR,SHIFTL
C     Functions called   : LIMITR8
C     File usage         : file with meteo data               
C ----------------------------------------------------------------------
      IMPLICIT NONE

c --- global
      character wthfil*15,envstr*50
      integer*4 iporwl,year,daynr,isua,swetr,istage,icrmod,logf,swshf
      integer*4 swgc,swrai,idev,swcf,swcfbs
      real*8    t,dt,lat,alt,kdif,kdir,lai,gird,rad,tav,tavd,tmnr,rh
      real*8    grai,nrai,nird,atmdem,ptra,peva,raitim(100),raiflx(100)
      real*8    arflux,cfbs,rsc,cofab,gc,cf
      logical   flrai,flraic,flrdme

c --- local
      character ext*3,cyear*4,filnam*80,raifil*16,line*80
      character*80 station(366),chdum
      integer*4 daynrf,daynrl,wth,rai,y,m,d,i,j,icount,nofd,nr,iost
      integer*4 ifnd,ad(366),am(366),ay(366)
      integer*4 daynumber,h,mn,getun2,ivals
      real*8    limitr8,crai,crold,a,aintc,b,cofbb,es0,et0,etr,ew0,hum
      real*8    rcc,rcs,rflux,rpd,svp,tim,timold,tmn,tmx,wfrac,win
      real*8    arad(366),atmn(366),atmx(366),ahum(366),awin(366)
      real*8    arai(366),aetr(366)
      real*8    radmin,radmax,tmnmin,tmnmax,tmxmin,tmxmax,hummin
      real*8    hummax,winmin,winmax,raimin,raimax,etrmin,etrmax

      logical   exists,blank,comment,dtleap


      SAVE

      DATA      RCS/0.15d0/,RCC/0.23d0/
C ----------------------------------------------------------------------

C *** Read meteo data file if flag FLRDME has been set *****************
C *** FLRDME is set in TIMER & reset here, after reading the meteo file 
      if (flrdme) then

C ---   Detection & handling of missing values ---------------------------
c       Default Ranges of parameter values
        radmin = -1.0d5
        radmax = 5.0d6
        tmnmin = -1.0d5
        tmnmax = 1.0d5
        tmxmin = -1.0d5
        tmxmax = 1.0d5
        hummin = -1.0d5
        hummax = 1.0d5
        winmin = -1.0d5
        winmax = 1.0d5
        raimin = 0.0
        raimax = 1.0d3
        etrmin = -1.0d5
        etrmax = 1.0d5
C ---   no missing values allowed if PENMON must be executed
        if (swetr.eq.0) then
          radmin = 0.0d0
          tmnmin = -50.0d0
          tmnmax = 35.0d0
          tmxmin = -30.0d0
          tmxmax = 60.0d0
          hummin = 0.0d0
          hummax = 10.0d0
          winmin = 0.0d0
          winmax = 50.0d0
        endif
C ---   error in case ETRef missing
        if (swetr.eq.1) then
          etrmin = -0.00001d0
          etrmax = 1.0d2
        endif  
C ---   no missing values for TMN and TMX allowed if cropD is present or
C ---   numerical soil temperatures or cropS development must be simulated
        if ((istage.eq.2.and..not.(icrmod.eq.1.and.idev.eq.1))
     &  .or.(istage.eq.1.and.(swshf.eq.2.and.iporwl.eq.2))) then
          tmnmin = -60.0d0
          tmnmax = 50.0d0
          tmxmin = -50.0d0
          tmxmax = 60.0d0
        endif
C ---   no missing value for RAD allowed in case the detailed crop model
C ---   or the grass routine is active 
        if (istage.eq.2.and.(icrmod.eq.2.or.icrmod.eq.3)) then
          radmin = 0.0d0
          radmax = 5.0d6
        endif
C ---   End of handling missing values -----------------------------------

C ---   Compose filename
        write (ext,'(i3.3)') mod(year,1000)
        filnam = trim(envstr)//trim(wthfil)//'.'//trim(ext)

C ---   initialise and start reading
        wth = getun2 (10,19,2)
        call rdinit(wth,logf,filnam)
*       get values from file
        ivals=365
        if (dtleap(year)) ivals=ivals+1
        call rdacha ('station', station,366, ivals)
        call rdfinr ('dd',1,31,ad,366,ivals)
        call rdfinr ('mm',1,12,am,366,ivals)
        call rdfinr ('yyyy',year,year,ay,366,ivals)
        call rdfdor ('rad',radmin,radmax,arad,366,ivals)
        call rdfdor ('tmin',tmnmin,tmnmax,atmn,366,ivals)
        call rdfdor ('tmax',tmxmin,tmxmax,atmx,366,ivals)
        call rdfdor ('hum',hummin,hummax,ahum,366,ivals)
        call rdfdor ('wind',winmin,winmax,awin,366,ivals)
        call rdfdor ('rain',raimin,raimax,arai,366,ivals)
        call rdfdor ('etref',etrmin,etrmax,aetr,366,ivals)
*       close temporary file
        close (wth)

        call datonr (year,am(1),ad(1),daynrf) 
        call datonr (year,am(ivals),ad(ivals),daynrl) 

C ---   check date 
        do 4 i = 1,ivals
          call datonr (ay(i),am(i),ad(i),daynumber)
          if (daynumber.ne.i) then 
		  write (*,202) filnam,ad(i),am(i)
		  write (logf,202) filnam,ad(i),am(i)
 202        format('in meteo file ',a,'the date of ',i2,'/',i2,1x,
     &             'is not correct!')
            write(*,*) ' interrupt: first adapt meteo file !'
            stop   
          endif
4       continue
        flrdme = .false.
      endif

C *** End of reading meteo data file *************************************************

c --- the weather for today     

      CALL NRTODA (YEAR,DAYNR,M,D)
      Y = YEAR

      IF (DAYNR.LT.DAYNRF.OR.DAYNR.GT.DAYNRL)
     &  STOP 'METEO - no meteo data for today available'

      RAD  = ARAD(DAYNR)
      TMN  = ATMN(DAYNR)
      TMX  = ATMX(DAYNR)
      HUM  = AHUM(DAYNR)
      WIN  = AWIN(DAYNR)
      GRAI = ARAI(DAYNR)
      ETR  = AETR(DAYNR)
 
C --- Calculate running average of minimum temperature ----------------- 
      NOFD = MIN(DAYNR-DAYNRF+1,7)
      TMNR = 0.0
      DO 10 I = DAYNR-NOFD+1,DAYNR
        TMNR = TMNR + ATMN(I)/NOFD
 10   CONTINUE


C --- if HUM is missing or TAV cannot be calculated: set RH at -99.0
      RH = 1.0d0
      IF (HUM.LT.-98.0d0.OR.TMN.LT.-98.0d0.OR.TMX.LT.-98.0d0) RH=-99.0d0


C --- convert radiation from kJ/m2 to J/m2
      RAD = RAD*1000

C --- calculate 24h average temperature
      TAV  = (TMX+TMN)/2
C --- calculate average day temperature
      TAVD = (TMX+TAV)/2

      IF (RH.GE.-98.0d0) THEN
C ---   calculate saturated vapour pressure [kPa]
        SVP = 0.611*EXP(17.4*TAV/(TAV+239.0d0))
C ---   calculate relative humidity [fraction]
        RH  = MIN(HUM/SVP,1.0d0)
C ---   calculate vapour pressure deficit [mbar]
c       VPD = (SVP-HUM)*10
      ENDIF
 
C --- gross rainfall in cm
      GRAI = GRAI/10.0

C --- Calculation of Net RAIn & Net IRrigation Depth [cm] --------------

      IF (LAI.LT.0.001d0) THEN
C --- no vegetation
        NRAI = GRAI
        NIRD = GIRD
      ELSE

C --- Calculate interception, method H.Braden

        RPD = GRAI*10.0
        IF (ISUA.EQ.0) RPD = (GRAI+GIRD)*10.0

        COFBB = MIN (LAI/3.0,1.0d0)
        If (CofAb.GT.0.000001d0) then
          AINTC = (COFAB*LAI*(1.0d0-(1/(1.0d0+RPD*COFBB/
     &    (COFAB*LAI)))))/10.0
        else
          AINTC = 0.0
        Endif

C --- divide interception into rain part and irrigation part

        IF (AINTC.LT.0.001d0) THEN
          NRAI = GRAI          
          NIRD = GIRD
        ELSE
           IF (ISUA.EQ.0) THEN
             NRAI = GRAI-AINTC*(GRAI/(GRAI+GIRD)) 
             NIRD = GIRD-AINTC*(GIRD/(GRAI+GIRD)) 
           ELSE 
             NRAI = GRAI-AINTC
             NIRD = GIRD
           ENDIF
        ENDIF
  
      ENDIF

C ----------------------------------------------------------------------
C --- calculation of Angstrom coefficients A and B
      A = 0.4885d0-0.0052*LAT
      B = 0.1563d0+0.0074*LAT

C --- Calculate evapotranspiration: ET0, EW0, ES0

C --- reference evapotranspiration has been specified 
      IF (SWETR.EQ.1) THEN
        If (Istage.EQ.1) then
C ---   no crop 
          ET0 = 0.0
          EW0 = 0.0
          ES0 = ETR
          if (SWCFBS.EQ.1) ES0 = CFBS*ETR
        elseif (Istage.EQ.2) then
C ---   yes crop
          if (SWCF.EQ.1) then 
            ET0 = CF*ETR
            EW0 = CF*ETR
          else
            ET0 = ETR
            EW0 = ETR
          endif 
          ES0 = ETR
          if (SWCFBS.EQ.1) ES0 = CFBS*ETR
        endif   
C --- reference evapotranspiration must be calculated
      ELSE
        CALL PENMON (DAYNR,LAT,ALT,A,B,RCS,RCC,RAD,TAV,HUM,
     &  WIN,RSC,ES0,ET0,EW0,SWCF,CF,IStage)
        If (Istage.EQ.1) then
C ---     no crop 
          ET0 = 0.0
          EW0 = 0.0
          if (SWCFBS.EQ.1) ES0 = CFBS*ES0
        elseif (Istage.EQ.2) then
C ---     yes crop
          if (SWCF.EQ.1) then 
            ET0 = CF*ET0
            EW0 = CF*EW0
          endif 
          if (SWCFBS.EQ.1) ES0 = CFBS*ET0
        ENDIF
      ENDIF

C --- ET0, EW0 and ES0 are always defined !

C --- Calculate atmospheric demand [cm]
      ATMDEM = ET0/10.0d0

C --- Calculate fraction of the day the crop is wet
      IF (EW0.LT.0.0001d0) THEN 
        WFRAC = 0.0d0
      ELSE
        WFRAC = LIMITR8 (0.0d0,1.0d0,AINTC*10.0d0/EW0)
      ENDIF

C --- Potential soil evap. (PEVA) & transpiration (PTRA) [cm]
      PEVA = MAX (0.0d0,ES0*EXP(-1.0d0*KDIR*KDIF*LAI))/10.0d0
      PTRA = MAX (1.0d-9,(1.0d0-WFRAC)*ET0-PEVA*10.0d0)/10.0d0
C --- alternative (simple model, soil cover fraction specified)
      IF (ISTAGE.EQ.2.AND.ICRMOD.EQ.1.AND.SWGC.EQ.2) THEN
        PEVA = (1.0d0-GC)*(1.0d0-WFRAC)*ES0/10.0d0
        PTRA = MAX(1.0d-9,GC*(1.0d0-WFRAC)*ET0)/10.0d0
      ENDIF

C ----------------------------------------------------------------------
C --- Detailed rainfall      
   
      FLRAI = .FALSE.
      IF (SWRAI.EQ.1) THEN
        IF (IPORWL.EQ.2) THEN

          DO 16 I = 1,100
            RAITIM(I) = 2.0d0       
            RAIFLX(I) = 0.0d0
16        CONTINUE
          TIMOLD = 0.0d0
          CROLD  = 0.0d0
          ICOUNT = 1

C -       Compose filename
          write (ext,'(i3.3)') mod(year,1000)
          filnam = trim(envstr)//trim(wthfil)//'R.'//trim(ext)

C -       initialise and start reading
          rai = getun2 (10,19,2)
          call fopens (rai,filnam,'old',' ')

*         get values from file
20        READ (RAI,'(A)',IOSTAT=IOST) LINE
            IF (IOST.LT. 0) GOTO 100
            CALL ANALIN (LINE,BLANK,COMMENT)
            IF (BLANK.OR.COMMENT) GOTO 20

            BACKSPACE (RAI)
            READ (RAI,*) CHDUM,D,M,Y,H,MN,CRAI
            CALL DATONR (Y,M,D,NR)

            IF (NR.NE.DAYNR.AND.FLRAI) GOTO 100
            IF (NR.NE.DAYNR) GOTO 20

            FLRAI = .TRUE.

            TIM   = H/24.0 + MN/1440.0

C ---       skip record if time does not proceed (TIM-TIMOLD ~ 0)
          IF (TIM-TIMOLD.LT.1.0d-6) GOTO 20

          IF (GRAI.LT.0.000001d0) THEN
              RFLUX = 0.0
          ELSE
              RFLUX = (((CRAI-CROLD)/(TIM-TIMOLD)) * (NRAI/GRAI))/10.0 
          ENDIF
          RAITIM (ICOUNT) = TIMOLD
          RAIFLX (ICOUNT) = RFLUX

          TIMOLD = TIM
          CROLD  = CRAI
          ICOUNT = ICOUNT+1
          GOTO 20     

C ---       end of file reached
100       CLOSE (RAI)

C ---       period from last recording till end of the day
          IF (FLRAI) THEN
              IF (ABS(TIM-1.0d0).GT.1.0d0/1440.0d0) THEN
                RAITIM (ICOUNT) = TIM
                RAIFLX (ICOUNT) = 0.0
              ENDIF
          ENDIF

        ENDIF
      ENDIF

C --- actual rain flux
      IF (FLRAI) THEN
        ARFLUX = RAIFLX(1)
      ELSE
        ARFLUX = NRAI
      ENDIF

C --- check time step for next rain record 
      IF (T+DT .GT. (INT(T)+RAITIM(2))-1.0d-4 .AND. 
     &    RAIFLX(1) .GT. 1.d-6) THEN
        DT     = (INT(T)+RAITIM(2))-T
        FLRAIC = .TRUE.
      ENDIF

      RETURN
      END

C ----------------------------------------------------------------------
      SUBROUTINE SOIL(ITASK,prjdes,RUNNR,ISEQ,FLOUT,FL1ST,ENVSTR,
     &  SW1FIL,OUTFIL,BBCFIL,DRFIL,BAYRY,BAYRD,DAYNR,ECMAX,
     &  ECSLOP,SWBALANCE,DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,
     &  DT,DRZ,GRAI,GIRD,PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,
     &  ADCRL,ADCRH,ATMDEM,LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,
     &  FLGENU,COFGEN,THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,
     &  DTMAX,DTMIN,NUMBIT,THETOL,GWLCONV,QTOP,
     &  HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RDCTB,RDM,
     &  BRUNY,ERUNY,BRUND,ERUND,SWHEA,WLS,RSRO,SWDRA,POND,PONDMX,
     &  AFO,AUN,ATE,AIR,PERIOD,
     &  SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &  SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &  SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,FlDecDtMin,FlDtMin,
     &  PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &  FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &  MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &  COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI,DAYNRC,CF,FlDecDt)

C ----------------------------------------------------------------------
C     Date      : 6/5/2001
C     Purpose   : SWAP soil submodel
C ----------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE 'PARAM.FI'

      INTEGER   ITASK,RUNNR,ISEQ,SWHEA,SWDRF,SWSWB,LOGF,FMAY
      INTEGER   SWREDU,NUMLAY,NUMNOD,BOTCOM(MAHO),SWSCAL,SWMOBI,DAYNRC
      INTEGER   SWSHF,SWSRF,SWB,DRF,SWBR,SWSCRE,ErrorCode
      INTEGER   ISCLAY,SWHYST,SWDRA,SWSOLU,SWINCO,SWVAP,SWCRACK
      INTEGER   BAYRD,BAYRY,SWBOTB,THETLO(MAHO),THETHI(MAHO),LAYER(MACP)
      INTEGER   INDEKS(MACP),SWALLO(5),SWDTYP(5),NPEGWL
      INTEGER   NRPRI,NRSEC,NRSRF,SWQHR,NQH(10),SWSEC,NODHD(10)
      INTEGER   NRLEVS,DAYNR,YEAR,OUTPER,LEVEL,N,IMPER
      INTEGER   DAYSTA,WBA,VAP,SBA,TEP,NUMBIT,DRAMET,DAT,INC
      INTEGER   NMPER,IMPEND(10),SWMAN(10),NPHASE(10),INTWL(10),NODGWL
      INTEGER   NNCRACK,DNOCON,I,BRUNY,ERUNY,BRUND,ERUND,IPOS,NUMADJ
      INTEGER   SWAFO,SWAUN,SWATE,SWAIR,AFO,AUN,ATE,AIR,PERIOD,SWDIVD
	INTEGER   SWNRSRF,SWBALANCE,sw1fil

      REAL*8    PONDMX,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,FSCALE(MAYRS)
      REAL*8    HLIM4,CPRE,CMLI(MACP),DDIF,LDIS,TSCF,KF,CREF
      REAL*8    FREXP,KMOBIL,DECPOT,GAMPAR,RTHETA,BEXP,TAMPLI
      REAL*8    TMEAN,DDAMP,TIMREF,FDEPTH(MAHO),FMOBIL(MACP),PF1(MAHO)
      REAL*8    FM1(MAHO),HDRAIN,PEGWL
      REAL*8    PF2(MAHO),FM2(MAHO),SLOPFM(MAHO),QIMMOB(MACP),GWLI
      REAL*8    GWLTAB(732),SHAPE,RIMLAY,AQAVE,AQAMP,AQTAMX,AQOMEG
      REAL*8    QBOTAB(732),COFQHA,COFQHB,HGITAB(732)
      REAL*8    DZ(MACP),Z(MACP),DISNOD(MACP+1),INPOLA(MACP)
      REAL*8    INPOLB(MACP),T,TCUM,QCOMP
      REAL*8    GWL,GWLBAK(4),RSRO,ORGMAT(MAHO)
      REAL*8    CML(MACP),CIL(MACP),CL(MACP),CMSY(MACP),CISY(MACP)
      REAL*8    INQROT(MACP),INQ(MACP+1),INQDRA(5,MACP),IQROT,IQDRA
      REAL*8    IINTC,AFGEN,PSAND(MAHO),PSILT(MAHO),PCLAY(MAHO)
      REAL*8    IPTRA,IPEVA,IEVAP,IRUNO,IPREC,IQBOT,IGRAI,IGIRD
      REAL*8    QBOT,DT,QROT(MACP),QDRA(5,MACP),TEMPI(MACP)
      REAL*8    POND,L(5),ZBOTDR(5),OWLTAB(5,2*MAOWL)
      REAL*8    BASEGW(2),WETPER(5),DRARES(5),QDRTAB(50)
      REAL*8    CQROT,CQDRA,CQBOT,CPTRA,CPEVA,CEVAP,CRUNO
      REAL*8    CGRAI,CNRAI,CGIRD,CNIRD
      REAL*8    REVA,PEVA,GRAI,NRAI,GIRD,NIRD,TAV,DTSOLU
      REAL*8    ECMAX,ECSLOP,ADCRH,ADCRL,ATMDEM,THETOL,DTMAX,DTMIN
      REAL*8    WIDTHR(5),TALUDR(5),RDRAIN(5),RINFI(5),RENTRY(5)
      REAL*8    REXIT(5),GWLINF(5),WLPTAB(2*MAWLP),WLS,WLSTAR,WLP
      REAL*8    WLDIP(10)
      REAL*8    HQHTAB(10,10),QQHTAB(10,10),WLSMAN(10,10),HDEPTH(10)
      REAL*8    HBWEIR(10),ALPHAW(10),BETAW(10),DROPR(10),GWLCRIT(10,10)
      REAL*8    WSCAP(10),WLSTAB(2*MAWLS),STTAB(22,2),WSTINI,WST,QDRTOT      
      REAL*8    DRAINL(5),QDRAIN(5),CQDRAIN(5),RDCTB(22),RDM,VTAIR
      REAL*8    HCRIT(10,10),VCRIT(10,10),cqdrd,cwsupp,cwout,HWLMAN
      REAL*8    SHRINA,MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF
      REAL*8    SHRINB,SHRINC,THETCR(MAHO),ACRACK,QCRACK,RAPDRA,WTOPLAT
      REAL*8    ADSFLU(MACP),IQDRAR,IQCRACK,CQDRAR,CQCRACK,CRACKW
      REAL*8    SQPREC,SQIRRIG,PONDM1,CPOND,CRACKC,CKWM1,SOLBAL
      REAL*8    ARFLUX,CIRR,DPTRA,DQROT,DRZ,PTRA,QTOP
      REAL*8    RUNOTS,WLSBAK(4),OSSWLM,HSURF,CRALEV,DIFDES
      REAL*8    HAQUIF,POROS,KFSAT,DECSAT,CDRAIN,SAMINI,DECTOT,ROTTOT
      REAL*8    SAMPRO,SAMCRA,SQBOT,SQDRA,SQSUR,SQRAP,SAMAQ,CSURF
      REAL*8    KHTOP,KHBOT,KVTOP,KVBOT,ENTRES,ZINTF,GEOFAC,INFRES(5)
      REAL*8    QDRD,QROSUM,COFRED,RSIGNI,COFANI(MAHO),SDRAIN,gwlinp
      real*8    RSURFDEEP,RSURFSHALLOW
      REAL*8    BDENS(MAHO),FQUARTZ(MACP),FCLAY(MACP),FORG(MACP),WLSOLD
      REAL*8    GC,LAI,INIRD,INRAI,CF

      REAL*8    TAU,THETIM(MAHO),THETAI(MACP),HI(MACP),HTABLE(MAHO,99)
      REAL*8    KTABLE(MAHO,99),TSoil(0:MACP) 
      REAL*8    THETSL(MAHO),KSAT(MAHO),DMCH(MAHO,99),DMCC(MAHO,99)
      REAL*8    COFGEN(8,MAHO)
      REAL*8    KSE99(MAHO),THETAS(MACP),THETAR(MACP),ALFAMG(MACP)
      REAL*8    THETA(MACP),H(MACP),VOLM1,VOLACT,VOLINI,VOLSAT
      REAL*8    THETM1(MACP),WBALANCE,GWLCONV,RECIRES,AQATAB(732)
      REAL*8    HM1(MACP),DIMOCA(MACP),K(MACP+1),KMEAN(MACP+1),Q(MACP+1)

      CHARACTER ENVSTR*50,OUTFIL*16,BBCFIL*16,DRFIL*16
      CHARACTER*16 SOLFIL(MAHO)
      CHARACTER*16 AFONAM,AUNNAM,ATENAM,AIRNAM,PRJNAM
      character*80 prjdes

      LOGICAL   FLGENU(MAHO),HWBAD,HVAPD,HSBAD,HAFOD,HAUND,HTEPD,FLTSAT
      LOGICAL   FL1ST,FLOUT,FTOPH,HSWBD,HDRFD,HLEVD
      LOGICAL   FLREVA,OVERFL,HATED,HAIRD,HINCD,FPEGWL

      REAL*8    HATM, REVADEEP, THETASURF,HEVAPFRONT,EVP(MACP)
	LOGICAL   FLDTMIN,FLEVAPFRONT,FLDECDT,FLDECDTMIN
      INTEGER   NODEEVAPFRONT
      integer*4 getun

	INTEGER   GETERRORSTATUS
      EXTERNAL  GETERRORSTATUS

      SAVE

C ----------------------------------------------------------------------
      GOTO (1000,2000,3000,4000) ITASK

1000  CONTINUE

C --- INITIALIZATION ---------------------------------------------------

      QTOP = 0.d0
	QCOMP = 0.d0
      HATM = -2.75d+05

      IF (RUNNR.EQ.1.OR.ISEQ.EQ.0) then 
        IF (SWSOLU.EQ.1) THEN
          CALL RDSLT (PRJNAM,ENVSTR,LOGF,CPRE,CMLI,DDIF,LDIS,TSCF,KF,
     &    FREXP,CREF,DECPOT,GAMPAR,RTHETA,BEXP,FDEPTH,KMOBIL,
     &    HAQUIF,POROS,KFSAT,DECSAT,CDRAIN,NUMNOD,NUMLAY,SWBR)
        ENDIF
        IF (SWHEA.EQ.1) THEN
          CALL RDHEA (PRJNAM,ENVSTR,LOGF,SWSHF,TAMPLI,TMEAN,DDAMP,
     &    TIMREF,TEMPI,NUMNOD)
        ENDIF
      ENDIF

C --- read input file containing bottom boundary conditions
      CALL RDBBC (runnr,iseq,sw1fil,BBCFIL,ENVSTR,BAYRD,BAYRY,GWLTAB,
     & SHAPE,RIMLAY,AQAVE,AQAMP,AQTAMX,AQOMEG,QBOTAB,COFQHA,COFQHB,
     & HGITAB,SWBOTB,LOGF,YEAR,FMAY,HDRAIN,AQATAB,RECIRES)

C --- First year only
      IF (RUNNR.EQ.1.OR.ISEQ.EQ.0) THEN

C ---   read input file(s) containing soil physical data for SWAP
        do I = 1,NUMLAY
          call RDSOL (SOLFIL(I),ENVSTR,I,FLGENU,THETHI,THETLO,
     &    HTABLE,KTABLE,THETSL,KSAT,DMCH,DMCC,COFGEN,SWSCAL,ISCLAY,
     &    FSCALE,RUNNR,KSE99,LOGF,SWHYST)
        enddo

        CALL INITSOL (NUMLAY,FLGENU,THETHI,
     & THETLO,HTABLE,KTABLE,THETSL,KSAT,DMCH,DMCC,COFGEN,
     & KSE99,NUMNOD,DZ,Z,DISNOD,INPOLB,INPOLA,BOTCOM,
     & LAYER,THETAS,THETAR,SWHYST,INDEKS,ALFAMG,SWINCO,THETA,
     & THETAI,H,SWBOTB,HGITAB,T,HI,GWLTAB,GWLI,GWL,GWLBAK,
     & SWSOLU,CMLI,CML,CIL,SAMINI,PSAND,PSILT,PCLAY,ORGMAT,
     & CL,CMSY,KF,FREXP,CISY,VOLM1,VOLACT,VOLINI,VOLSAT,CREF,
     & THETM1,HM1,DIMOCA,K,KMEAN,THETIM,SWMOBI,FMOBIL,KMOBIL,PF1,FM1,
     & PF2,FM2,SLOPFM,QIMMOB,SWCRACK,SHRINA,MOISR1,MOISRD,ZNCRACK,
     & SHRINB,SHRINC,NNCRACK,ACRACK,QCRACK,RAPDRA,WTOPLAT,ADSFLU,
     & CKWM1,DT,POND,BDENS,FQUARTZ,FCLAY,FORG)
        IF (GetErrorStatus().ne.0) RETURN
        DO 8 I = 1,NUMLAY
          IF (.NOT.FLGENU(I).AND.SWHYST.NE.0)
     &    STOP 'Hysteresis option not allowed'
8       CONTINUE

        CALL ZEROINTR (NUMNOD,INQROT,INQ,INQDRA,IQROT,IQDRA,IINTC,
     &  IPTRA,IPEVA,IEVAP,IRUNO,IPREC,IQBOT,OUTPER,IQDRAR,IQCRACK,
     &  IGRAI,IGIRD,INRAI,INIRD)

        IF (SWHEA.EQ.1) THEN
	    IF (SWSHF.EQ.1) THEN 
C ---       Analytical solution soil temperatures
	      CALL SOILTMP (NUMNOD,THETA,THETM1,THETAS,TAV,
     &      SWSHF,TSoil,DZ,DISNOD,DT,TAMPLI,TMEAN,
     &      DDAMP,TIMREF,DAYNR,Z,FQUARTZ,FCLAY,FORG)
          ELSE
C ---       Numerical solution soil temperatures
            DO 10 I = 1,NUMNOD
              TSoil(I) = TEMPI(I)
   10       continue
          ENDIF
        ENDIF

        HAFOD = .FALSE.
        HAUND = .FALSE.
        HATED = .FALSE.
        HAIRD = .FALSE.
      ENDIF

C --- misc.
      if (sw1fil.eq.0 .or. 
     &    sw1fil.eq.1 .and. (runnr.eq.1.or.iseq.eq.0)) then
        HTEPD = .FALSE.
        HWBAD = .FALSE.
        HINCD = .FALSE.
        HVAPD = .FALSE.
        HSBAD = .FALSE.
        HDRFD = .FALSE.
        HSWBD = .FALSE.
      endif
      HLEVD = .FALSE.
      FlDecDt = .FALSE.

C --- assign dummy values to variables of SWAPS
      REVADEEP = 0D+0
      THETASURF = 0D+0
      HEVAPFRONT = 0D+0
      NODEEVAPFRONT = 0
      DO I=1,MACP
        EVP(I)=0D+0
      ENDDO
      FLEVAPFRONT = .FALSE.

C --- read input file(s) containing drainage & surface water system par.
      IF (SWDRA.EQ.1) THEN
        CALL RDDRB (DRFIL,ENVSTR,BAYRD,BAYRY,DRAMET,
     &  IPOS,BASEGW,KHTOP,KHBOT,KVTOP,KVBOT,ZINTF,L,WETPER,ZBOTDR,
     &  ENTRES,GEOFAC,NRLEVS,DRARES,INFRES,SWALLO,SWDTYP,OWLTAB,QDRTAB,
     &  LOGF,FMAY,SWDIVD)
      ELSEIF (SWDRA.EQ.2) THEN
        CALL RDDRE (DRFIL,ENVSTR,RSRO,NRSRF,NRPRI,NRSEC,L,
     &  ZBOTDR,WIDTHR,TALUDR,RDRAIN,RINFI,RENTRY,REXIT,GWLINF,SWDTYP,
     &  WLPTAB,BAYRD,BAYRY,SWSEC,WLS,OSSWLM,NMPER,
     &  WLSTAR,IMPEND,SWMAN,WSCAP,SWQHR,HBWEIR,ALPHAW,BETAW,NQH,HQHTAB,
     &  QQHTAB,DROPR,WLSMAN,GWLCRIT,WLSTAB,STTAB,WSTINI,WST,T,WLSBAK,
     &  SWSRF,NPHASE,HCRIT,HDEPTH,VCRIT,WLP,NODHD,NUMNOD,DZ,WLDIP,
     &  NUMADJ,LOGF,FMAY,INTWL,SWNRSRF,RSURFDEEP,RSURFSHALLOW)
        NRLEVS = NRSRF
        IF (SWSWB.EQ.1) THEN
          CALL OUTSWB (LOGF,OUTFIL,SWB,HSWBD,ENVSTR,DAYNR,YEAR,
     &    GWL,POND,WLSTAR,WLS,WSTINI,WST,CQDRD,CRUNO,CQDRAR,CWSUPP,
     &    CWOUT,NUMADJ,HWLMAN,VTAIR,OVERFL,SWSEC,SWMAN,NMPER,IMPEND,
     &    IMPER,HBWEIR,T)
	    if (GetErrorStatus().ne.0) return
        ENDIF
      ENDIF

C --- set intermediate totals to zero
      CALL ZEROINTR (NUMNOD,INQROT,INQ,INQDRA,IQROT,IQDRA,IINTC,
     & IPTRA,IPEVA,IEVAP,IRUNO,IPREC,IQBOT,OUTPER,IQDRAR,IQCRACK,
     & IGRAI,IGIRD,INRAI,INIRD)

C --- set initial values
      CALL ZEROCUMU (CQROT,CQDRA,CQBOT,CPTRA,CPEVA,CEVAP,CRUNO,
     &CGRAI,CNRAI,CGIRD,CNIRD,CQDRAR,CQCRACK,
     &CQDRAIN,CQDRD,CWSUPP,CWOUT,SQBOT,SQDRA,SQSUR,SQRAP,DECTOT,
     &ROTTOT,SQPREC,SQIRRIG,CSURF)

C --- ANIMO output, initial situation, first year only
      IF (RUNNR.EQ.1.OR.ISEQ.EQ.0) THEN
        IF (SWAFO.GE.1) THEN
          CALL OUTAFO (AFO,AFONAM,HAFOD,ENVSTR,
     &    NUMNOD,OUTPER,PERIOD,TCUM,POND,GWL,THETA,H,INQ,
     &    INQROT,NRLEVS,INQDRA,IEVAP,IPEVA,IPTRA,IRUNO,
     &    NUMLAY,BOTCOM,DZ,THETAS,BRUNY,ERUNY,BRUND,ERUND,
     &    LAYER,FLGENU,ALFAMG,THETAR,COFGEN,HTABLE,THETLO,
     &    SWAFO,TEMPI,IGRAI,IGIRD,INRAI,INIRD,GC,LAI,TAV,TSoil,DAYNRC,
     &    DRZ,CF,WBALANCE,prjdes)
        ENDIF
        IF (SWAUN.GE.1) THEN
          CALL OUTAUN (AUN,AUNNAM,HAUND,ENVSTR,
     &    NUMNOD,OUTPER,PERIOD,TCUM,POND,GWL,THETA,H,INQ,
     &    INQROT,NRLEVS,INQDRA,IEVAP,IPEVA,IPTRA,IRUNO,
     &    NUMLAY,BOTCOM,DZ,THETAS,BRUNY,ERUNY,BRUND,ERUND,
     &    LAYER,FLGENU,ALFAMG,THETAR,COFGEN,HTABLE,THETLO,
     &    SWAUN,TEMPI,IGRAI,IGIRD,INRAI,INIRD,GC,LAI,TAV,TSoil,DAYNRC,
     &    DRZ,CF,WBALANCE,prjdes)
        ENDIF
      ENDIF

C --- profile output, initial situation, first year only
      IF ((RUNNR.EQ.1 .OR. ISEQ.EQ.0) .AND. (SWVAP.EQ.1))
     &   CALL OUTVAP (SWSOLU,OUTFIL,VAP,HVAPD,ENVSTR,DAYNR,
     &   YEAR,NUMNOD,Z,THETA,H,CML,SWHEA,TSoil,T,Q)

      RETURN

2000  CONTINUE

C --- TIMESTEP LOOP ----------------------------------------------------

C --- only first timestep of the day
      IF (FL1ST) THEN
        CALL REDUCEVA (SWREDU,REVA,PEVA,DAYNR,DAYSTA,NRAI,
     &  NIRD,RUNNR,ISEQ,COFRED,RSIGNI)
	  QCOMP = 0.0
        CALL CALCGWL(GWL,GWLBAK,NUMNOD,H,Z,DZ,SWBOTB,POND,NODGWL,
     &  FPEGWL,NPEGWL,PEGWL,GWLTAB,T)
        FL1ST = .FALSE.
	  IF (GetErrorStatus().ne.0) RETURN 
      ENDIF

C --- calculate lateral drainage
      IF (GWL.GT.998.0d0) THEN
        Do 2001 level = 1,nrlevs
          QDRAIN(level) = 0.0
 2001   continue
      ELSEIF (SWDRA.EQ.1) THEN
        CALL BOCODRB (DRAMET,GWL,ZBOTDR,POND,BASEGW,L,QDRAIN,IPOS,
     &  KHTOP,KHBOT,KVTOP,KVBOT,ENTRES,WETPER,ZINTF,GEOFAC,SWDTYP,
     &  OWLTAB,T,SWALLO,DRARES,INFRES,QDRTAB,NRLEVS)
	  if (GetErrorStatus().ne.0) return
      ELSEIF (SWDRA.EQ.2) THEN
        CALL BOCODRE (SWSEC,SWSRF,NRSRF,NRPRI,GWL,ZBOTDR,TALUDR,
     &  WIDTHR,POND,PONDMX,SWDTYP,DT,WLS,WLP,DRAINL,L,RDRAIN,RINFI,
     &  RENTRY,REXIT,GWLINF,WETPER,QDRAIN,QDRD,T,IMPEND,NMPER,WSCAP,WST,
     &  SWNRSRF,RSURFDEEP,RSURFSHALLOW)
	  if (GetErrorStatus().ne.0) return
      ENDIF

      IF (SWDRA.GE.1) THEN
        IF (SWDIVD.EQ.1) THEN
C ---   partition drainage flux over compartments
          CALL DIVDRA (NUMNOD,NRLEVS,DZ,KSAT,LAYER,COFANI,GWL,L,
     &    QDRAIN,QDRA)
        ELSE
C ---   drainage flux through lowest compartment 
          do 102 level=1,nrlevs
            do 104 n=1,numnod-1
              qdra(level,n) =0.0
 104        CONTINUE
            qdra(level,numnod) =qdrain(level)
102       CONTINUE
        ENDIF
      ENDIF

C --- calculate bottom boundary conditions and restrict saturated flux
      CALL BOCOBOT (SWBOTB,GWL,GWLTAB,T,H,Z,LAYER,FLGENU,COFGEN,
     & HTABLE,THETLO,ALFAMG,THETAR,THETAS,THETHI,DMCH,DMCC,KTABLE,KSE99,
     & KSAT,FMOBIL,THETA,DIMOCA,K,KMEAN,QBOT,QBOTAB,AQAVE,
     & AQAMP,AQOMEG,AQTAMX,RIMLAY,COFQHA,COFQHB,HGITAB,NUMNOD,
     & SWMOBI,FM1,PF1,SLOPFM,NODGWL,SWDRA,QDRTOT,QDRA,NRLEVS,
     & QDRAIN,HDRAIN,SHAPE,GwlInp,RECIRES,AQATAB)
	IF (GetErrorStatus().ne.0) RETURN

C --- determine flow crack
      IF (SWCRACK.EQ.1) CALL CRACK (LAYER,NNCRACK,THETSL,THETA,SHRINA,
     & SHRINB,
     & SHRINC,ACRACK,WTOPLAT,GEOMF,POND,NUMNOD,ADSFLU,THETCR,Z,DZ,
     & QCRACK,MOISR1,MOISRD,CRACKW,FLGENU,COFGEN,THETAR,THETAS,THETLO,
     & THETHI,KTABLE,KSE99,KSAT,SWMOBI,FMOBIL,H,DIAMPOL,DISNOD,RAPDRA,
     & RAPCOEF,CRALEV)
      if (GetErrorStatus().ne.0) return

C --- calculate top boundary conditions
      CALL BOCOTOP (POND,REVA,NIRD,DT,QTOP,QBOT,QDRTOT,
     & KMEAN,K,H,DISNOD,LAYER,FLGENU,COFGEN,THETA,THETIM,DZ,
     & HTABLE,THETLO,THETHI,KTABLE,ALFAMG,FTOPH,ARFLUX,THETAR,
     & THETAS,KSE99,KSAT,SWMOBI,FMOBIL,VOLSAT,VOLACT,ACRACK,QCRACK,
     & FLTSAT,HSURF,DTMIN,WTOPLAT,FLREVA,NUMNOD,QROSUM,
     & QCOMP,FPEGWL,NPEGWL,Q,swbotb,gwlinp,hAtm,FlDecDtMin,revadeep)
      If (FlDecDtMin) return

C --- calculate root extraction rates
      CALL ROOTEX (NUMNOD,QROT,DRZ,DZ,PTRA,Z,HLIM3H,HLIM3L,HLIM4,HLIM2U,
     & H,CML,BOTCOM,HLIM2L,HLIM1,ADCRL,ADCRH,ATMDEM,RDCTB,
     & RDM,SWSOLU,ECMAX,ECSLOP,LAYER,THETSL,THETA,QROSUM)

C --- calculate pressure heads and water contents
      CALL HEADCALC(NUMNOD,HM1,H,THETM1,THETA,NUMBIT,
     & FTOPH,DT,T,KMEAN,DZ,DISNOD,DIMOCA,QROT,QDRA,POND,QTOP,
     & LAYER,FLGENU,COFGEN,HTABLE,THETLO,THETHI,ALFAMG,THETAR,THETAS,
     & DMCH,DMCC,SWBOTB,THETOL,REVA,NIRD,QBOT,QDRTOT,
     & K,KTABLE,Q,ARFLUX,KSE99,KSAT,SWMOBI,FMOBIL,VOLSAT,VOLACT,
     & DTMIN,DNOCON,QIMMOB,FM1,PF1,SLOPFM,THETIM,ADSFLU,
     & ACRACK,QCRACK,FLTSAT,HSURF,WTOPLAT,FLREVA,QROSUM,
     & QCOMP,FPEGWL,NPEGWL,GWLINP,ERRORCODE,
     & FLEVAPFRONT,FLDTMIN,REVADEEP,FLDECDTMIN,
     & THETASURF,NODEEVAPFRONT,HEVAPFRONT,HATM,EVP,FLDECDT,
     & GwlTab,GwlConv,Z)
     
	If (GetErrorStatus().ne.0) return

      If (ErrorCode .Gt.0) Stop 'Error in HeadCalc'  

      If (FlDecDt) return

C --- calculation of groundwater level
      CALL CALCGWL(GWL,GWLBAK,NUMNOD,H,Z,DZ,SWBOTB,POND,NODGWL,
     &FPEGWL,NPEGWL,PEGWL,GWLTAB,T)
	IF (GetErrorStatus().ne.0) RETURN

C --- update soil temperature profile
      IF (SWHEA.eq.1) CALL SOILTMP (NUMNOD,THETA,THETM1,THETAS,TAV,
     & SWSHF,TSoil,DZ,DISNOD,DT,TAMPLI,TMEAN,DDAMP,TIMREF,DAYNR,Z,
     & FQUARTZ,FCLAY,FORG)

C --- calculate actual water content of profile
      CALL WATCON (VOLM1,VOLACT,NUMNOD,THETA,DZ,FMOBIL,LAYER,
     & THETIM,SWCRACK,CKWM1,CRACKW,WTOPLAT,QCRACK,ARFLUX,NIRD,ACRACK,
     & RAPDRA,DT) 

C --- update parameters for hysterese
      IF (SWHYST.NE.0) CALL UPDATE (NUMNOD,LAYER,H,HM1,INDEKS,TAU,
     &FLGENU,COFGEN,THETAR,THETAS,ALFAMG,THETLO,THETHI,DMCH,DMCC,DIMOCA,
     &SWMOBI,FM1,PF1,SLOPFM,HTABLE,THETA,NODGWL,DISNOD)

C --- integrate daily totals of fluxes
      CALL FLUXES (Q,QBOT,DT,INQ,NUMNOD,THETM1,THETA,DZ,QROT,
     &  QDRA,QIMMOB,ADSFLU,QTOP,QROSUM,QDRTOT,VOLACT,VOLM1,SWBOTB,
     &  QCRACK,FLREVA,POND,WTOPLAT,ARFLUX,NIRD,ACRACK,REVA,QCOMP,EVP)

      CALL INTEGRAL (PTRA,DT,PEVA,REVA,QBOT,POND,QTOP,NRAI,NIRD,
     & PONDMX,NUMNOD,QROT,QDRTOT,QDRAIN,DQROT,DPTRA,IQROT,INQROT,IQDRA,
     & NRLEVS,INQDRA,QDRA,GRAI,GIRD,IINTC,IPTRA,IPEVA,IEVAP,IRUNO,
     & IPREC,IQBOT,CQROT,CQDRA,CQDRAIN,CPTRA,CPEVA,CEVAP,CRUNO,
     & CGRAI,CNRAI,CGIRD,CNIRD,CQBOT,PONDM1,WTOPLAT,RAPDRA,
     & IQDRAR,IQCRACK,QCRACK,CQDRAR,CQCRACK,ACRACK,ARFLUX,T,
     & WLS,RSRO,RUNOTS,QROSUM,SWCRACK,SWDRA,IGRAI,IGIRD,INRAI,INIRD,
     & QCOMP,Volini,Volact,Crackw,WBALANCE,SWBALANCE)

C --- surface water system (extended drainage option only)
      IF (SWDRA.EQ.2) THEN
        IF (SWSRF .EQ. 3) THEN 
          wlp = AFGEN (WLPTAB,2*MAWLP,T+DT+1.0d0)
        ENDIF
        IF (SWSEC.EQ.2) THEN
C ---     water level of secondary system is simulated
          CALL WLEVBAL (HLEVD,NRPRI,impend,nmper,swman,imper,
     &     wlstar,wls,hbweir,gwl,wlsman,gwlcrit,nphase,dropr,sttab,
     &     wscap,dt,runots,rapdra,wst,zbotdr,alphaw,betaw,qdrd,cqdrd,
     &     cwsupp,cwout,wlsbak,osswlm,T,NUMNOD,THETAS,THETA,DZ,VCRIT,
     &     NODHD,HCRIT,H,SWQHR,QQHTAB,HQHTAB,wldip,hwlman,vtair,overfl,
     &     numadj,intwl)
	    if (GetErrorStatus().ne.0) return
        ELSEIF (SWSEC.EQ.1) THEN
C ---     water level of secondary system is input
          CALL WBALLEV (wls,t,wlstab,wst,
     &     sttab,dt,runots,rapdra,qdrd,cqdrd,cwsupp,cwout,WLSOLD)
        ENDIF
      ENDIF

C --- calculate solute concentrations
      IF (SWSOLU.EQ.1)
     &  CALL SOLUTE (CPRE,NIRD,CIRR,DT,NUMNOD,LAYER,INPOLA,
     &  INPOLB,CML,THETA,DDIF,LDIS,Q,DISNOD,THETSL,
     &  Z,GAMPAR,RTHETA,BEXP,DECPOT,FDEPTH,KF,FREXP,FMOBIL,
     &  TSCF,QROT,DZ,KMOBIL,CIL,QDRA,CMSY,THETIM,CISY,CL,DTSOLU,
     &  DTMAX,TSoil,CPOND,QTOP,WTOPLAT,ACRACK,ADSFLU,CRACKC, 
     &  ARFLUX,SWCRACK,CRACKW,CKWM1,RAPDRA,QCRACK,POND,CREF,
     &  QDRTOT,POROS,KFSAT,DECSAT,CDRAIN,HAQUIF,DECTOT,SAMPRO,SAMCRA,
     &  SAMAQ,CRALEV,DIFDES,ROTTOT,SQDRA,SWBR,SDRAIN,BDENS,SWHEA,CSURF)

C --- calculate mass balance of solute transport
      IF (SWSOLU.EQ.1)
     &  CALL SLTBAL (DT,NIRD,CIRR,ARFLUX,CPRE,QBOT,CDRAIN,CML,NUMNOD,
     &  QDRTOT,RAPDRA,CRACKC,SQBOT,SQSUR,SQRAP,SQPREC,SQIRRIG)

      RETURN

3000  CONTINUE

C --- END OF THE DAY ---------------------------------------------------

C --- set daily totals to zero
      DQROT = 0.0
      DPTRA = 0.0

C --- length of output period
      OUTPER = OUTPER+1

C --- OUTPUT SECTION

C --- AIR file, irrigations for ANIMO
      IF (GIRD.GT.0.0.AND.SWAIR.EQ.1) CALL OUTAIR (AIR,AIRNAM,HAIRD,
     &  ENVSTR,YEAR,DAYNR,TCUM,GIRD,CIRR,DAYNRC)

C --- skip if not flout 
      IF (FLOUT) then

C --   wba file 
        CALL OUTWBA (SW1FIL,OUTFIL,WBA,HWBAD,ENVSTR,DAYNR,YEAR,CGRAI,
     &  CNRAI,CGIRD,CNIRD,CRUNO,CQROT,CEVAP,CQBOT,CQDRA,CPTRA,
     &  CPEVA,GWL,T,CQDRAR,VOLACT,VOLINI,POND,RUNNR,SWSCRE,
     &  TCUM,DAYNRC,WBALANCE)

C --    inc file
        CALL OUTINC (OUTFIL,INC,HINCD,ENVSTR,DAYNR,YEAR,
     &  IGRAI,IGIRD,IINTC,IRUNO,IPTRA,IQROT,IPEVA,IEVAP,IQDRA,
     &  IQDRAR,IQBOT,T)

C --    tmp file
        IF (SWHEA.eq.1) CALL OUTTEP (OUTFIL,TEP,HTEPD,ENVSTR,
     &     DAYNR,YEAR,NUMNOD,TSoil,T)

C --    ATE file, soil temperatures
        IF (SWATE.EQ.1) CALL OUTATE (ATE,ATENAM,HATED,ENVSTR,
     &     NUMNOD,YEAR,DAYNR,TCUM,TEMPI,TSoil,TAV,DAYNRC)

C --    vap file
        IF (SWVAP.EQ.1) CALL OUTVAP (SWSOLU,OUTFIL,VAP,HVAPD,ENVSTR,
     &     DAYNR,YEAR,NUMNOD,Z,THETA,H,CML,SWHEA,TSoil,T,Q)

C --    slt file
        IF (SWSOLU.EQ.1) THEN 
          SOLBAL = SAMPRO + SAMCRA - SQPREC - SQIRRIG - SQBOT + SQDRA 
     &         + SQRAP + DECTOT + ROTTOT - SAMINI
          CALL OUTSBA (OUTFIL,SBA,HSBAD,ENVSTR,DAYNR,YEAR,
     &       DECTOT,ROTTOT,SAMPRO,SAMCRA,SQBOT,SQSUR,SQRAP,SAMAQ,
     &       SQDRA,T,SOLBAL,SQPREC,SQIRRIG)
        ENDIF

C --    drainage fluxes
        IF (SWDRA.EQ.2 .AND. SWDRF.EQ.1) THEN
          CALL OUTDRF (LOGF,OUTFIL,DRF,HDRFD,ENVSTR,DAYNR,YEAR,
     &    NRPRI,NRSRF,CQDRAIN,CQDRD,CRUNO,CQDRAR,T)
        ENDIF 

C --    surface water system
        IF (SWDRA.EQ.2 .AND. SWSWB.EQ.1) THEN
          CALL OUTSWB (LOGF,OUTFIL,SWB,HSWBD,ENVSTR,DAYNR,YEAR,
     &     GWL,POND,WLSTAR,WLS,WSTINI,WST,CQDRD,CRUNO,CQDRAR,CWSUPP,
     &     CWOUT,NUMADJ,HWLMAN,VTAIR,OVERFL,SWSEC,SWMAN,NMPER,IMPEND,
     &     IMPER,HBWEIR,T)
	    if (GetErrorStatus().ne.0) return
        ENDIF

C --    ANIMO output files
        IF (SWAFO.GE.1) THEN
          CALL OUTAFO (AFO,AFONAM,HAFOD,ENVSTR,
     &     NUMNOD,OUTPER,PERIOD,TCUM,POND,GWL,THETA,H,INQ,
     &     INQROT,NRLEVS,INQDRA,IEVAP,IPEVA,IPTRA,IRUNO,
     &     NUMLAY,BOTCOM,DZ,THETAS,BRUNY,ERUNY,BRUND,ERUND,
     &     LAYER,FLGENU,ALFAMG,THETAR,COFGEN,HTABLE,THETLO,
     &     SWAFO,TEMPI,IGRAI,IGIRD,INRAI,INIRD,GC,LAI,TAV,TSoil,DAYNRC,
     &     DRZ,CF,WBALANCE,prjdes)
        ENDIF
        IF (SWAUN.GE.1) THEN
          CALL OUTAUN (AUN,AUNNAM,HAUND,ENVSTR,
     &     NUMNOD,OUTPER,PERIOD,TCUM,POND,GWL,THETA,H,INQ,
     &     INQROT,NRLEVS,INQDRA,IEVAP,IPEVA,IPTRA,IRUNO,
     &     NUMLAY,BOTCOM,DZ,THETAS,BRUNY,ERUNY,BRUND,ERUND,
     &     LAYER,FLGENU,ALFAMG,THETAR,COFGEN,HTABLE,THETLO,
     &     SWAUN,TEMPI,IGRAI,IGIRD,INRAI,INIRD,GC,LAI,TAV,TSoil,DAYNRC,
     &     DRZ,CF,WBALANCE,prjdes)
        ENDIF

C --    set intermediate totals to zero
        CALL ZEROINTR (NUMNOD,INQROT,INQ,INQDRA,IQROT,IQDRA,IINTC,
     &   IPTRA,IPEVA,IEVAP,IRUNO,IPREC,IQBOT,OUTPER,IQDRAR,IQCRACK,
     &   IGRAI,IGIRD,INRAI,INIRD)

      end if

      return

4000  CONTINUE

C --- TERMINAL SECTION -------------------------------------------------

C --- bal file
      CALL OUTBAL (SW1FIL,OUTFIL,ENVSTR,DAYNR,YEAR,BRUND,BRUNY,BAYRD,
     &     BAYRY,CGRAI,CNRAI,CGIRD,CNIRD,CRUNO,CQROT,CEVAP,CQBOT,
     &     CQDRAIN,CQDRA,CQDRAR,VOLACT,VOLINI,Z,DZ,SWDRA,NUMNOD,
     &     NRLEVS,SAMINI,SAMPRO,SAMCRA,SQPREC,SQIRRIG,SQBOT,DECTOT,
     &     ROTTOT,SQRAP,SQDRA,SWSOLU,POND,runnr)

C --- write final soil water pressure heads
      dat = getun (20,30)
      call fopens(dat,envstr//'hfinal.dat','new','del')
      write (dat,'(10f11.3)') (h(i), i=1,numnod)
	close (dat)

C --- initial water content next simulation period
      volini = volact+pond
      if (sw1fil.eq.0) then
        close (wba)
        close (inc)
      endif
C --- initial solute amount next simulation period

      if (swsolu.eq.1) then
          samini = sampro + samcra
          if (sw1fil.eq.0)  close (sba)
      endif

      if (sw1fil.eq.0) then
        if (swhea.eq.1)  close (tep)
        if (swvap.eq.1)  close (vap)
        if (swdra.eq.2.and.swswb.eq.1) close (swb)
        if (swdra.eq.2.and.swdrf.eq.1) close (drf)
      endif

      return
      end

C ----------------------------------------------------------------------
      SUBROUTINE TIMER (TASK,IPORWL,RUNNR,ISEQ,FMAY,BRUND,BRUNY,BCRPD,
     & BCRPY,ECRPD,ECRPY,BSCHD,BSCHY,ERUND,ERUNY,IFINCR,DTMAX,
     & NUMNOD,H,DTMIN,T,TCUM,TM1,DT,DTM1,ID,DAYNR,DAYSTA,YEAR,FLLAST,
     & FLENDD,FLENDR,FLOUT,FLCROP,CRPNR,ISTAGE,IRMODE,BAYRD,BAYRY,
     & RAITIM,RAIFLX,FLRAI,ARFLUX,SWSOLU,DTSOLU,NUMBIT,THETOL,
     & QTOP,THETA,THETM1,NOFRNS,SWSCAL,FLCAL,CRPFIL,ICRMOD,CAPFIL,
     & IRGFIL,CALFIL,BBCFIL,DRFIL,OUTFIL,ENVSTR,WLS,RSRO,SWDRA,POND,
     & PONDMX,PERIOD,SWRES,FLRAIC,FLCOPY,LOGF,OUTD,OUTY,NOUTDA,SWSCRE,
     & DAYNRC,FLDECDT,FLDECDTMIN,FLDTMIN,MSTEPS,Model_ID,Model_date)
C ----------------------------------------------------------------------
C     Date               : 22/10/2001              
C     Purpose            : SWAP time keeper              
C     Subroutines called : SHIFTR, DATONR, NRTODA                   
C     Functions called   : FROMTO        
C     File usage         :                                 
C ----------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE 'PARAM.FI'

      INTEGER   BRUND,BRUNY,ERUND,ERUNY,FMAY,FDAY,LDJY,SWSCRE,IND
      INTEGER   BCRPD(3,MAYRS),BCRPY(3,MAYRS),BSCHD(3,MAYRS)
      INTEGER   BSCHY(3,MAYRS),MSTEPS,NSTEPS
      INTEGER   NOFCRP(MAYRS),ICRMOD(0:3,MAYRS),ECRPD(3,MAYRS)
      INTEGER   ECRPY(3,MAYRS),NOUTDA
      INTEGER   OUTD(1000),OUTY(1000),DAYNR,DAYSTA,YEAR,D,M
      INTEGER   BAYRD,BAYRY,RUNNR,FROMTO,SWSOLU,SWDRA
      INTEGER   TASK,IPORWL,ISEQ,NRM1,IRSTEP,ISTAGE,IRMODE,ID
      INTEGER   CRPNR,NUMNOD,DAYNRO,YEARO,NUMBIT,I,J,IFINCR
      INTEGER   NOFRNS,SWSCAL,CAL,PERIOD,CNTPER,SWRES,LOGF

      INTEGER D1(3),M1(3),Y1(3),D2(3),M2(3),Y2(3),D3(3),M3(3),Y3(3)
      INTEGER IType(3),ITIMES,IFND,DAYNRC
      integer*4 getun2

      REAL*8    RAITIM(100),RAIFLX(100),THETOL,QTOP,ARFLUX,POND
      REAL*8    T,TCUM,TM1,DT,DTM1,DTMIN,DTMAX,DTSOLU,WLS,RSRO,PONDMX
      REAL*8    H(MACP),THETA(MACP),THETM1(MACP),DTHETA

      CHARACTER   FILNAM*80,ENVSTR*50,LINE*80
      CHARACTER*16 CRPFIL(3,MAYRS),CAPFIL(3,MAYRS)
      CHARACTER*16 IRGFIL(MAYRS),CALFIL(MAYRS),DRFIL(MAYRS)
      CHARACTER*16 BBCFIL(MAYRS),OUTFIL(MAYRS)
      CHARACTER*2  EXT(MAYRS)
      CHARACTER*14 TMPNAM
      CHARACTER*16 CRPFLB(3),CAPFLB(3)
      CHARACTER*80 ERRTXT,ERRSCR, Model_ID, Model_date

      LOGICAL   FLENDD,FLENDR,FLOUT,FLLAST,FLRAI,FLCROP,FLRAIC,FlDecDt
      LOGICAL   FLCAL,EXISTS,FLCOPY,BLANK,COMMENT,FlDecDtMin,FlDtMin

      SAVE

      DATA EXT/'1 ','2 ','3 ','4 ','5 ','6 ','7 ','8 ','9 ','10',
     &         '11','12','13','14','15','16','17','18','19','20',
     &         '21','22','23','24','25','26','27','28','29','30',
     &         '31','32','33','34','35','36','37','38','39','40',
     &         '41','42','43','44','45','46','47','48','49','50',
     &         '51','52','53','54','55','26','57','58','59','60',
     &         '61','62','63','64','65','66','67','68','69','70'/

      DATA IND/0/
C ----------------------------------------------------------------------
*     T      := time since start of agricultural year
*     TCUM   := time since start of simulation
*     DAYNR  := daynumber from start of calendar year
*     ID     := daynumber from emergence of the crop
*     ISTAGE := no crop (1) or yes crop (2)
*     IRMODE := no scheduling (1) or yes scheduling (2)
C ----------------------------------------------------------------------
C --- tijdelijk
      LOGF = LOGF

      GOTO (1000,2000,3000) TASK

1000  CONTINUE

C === INITIALIZATION ===================================================

C --- first year only
      IF (RUNNR.EQ.1.OR.ISEQ.EQ.0) THEN

        DAYNR  = BRUND 
        DAYSTA = BRUND
        YEAR   = BRUNY

C ---   calculate T, BAYRD,BAYRY
        IF (FMAY.EQ.1) THEN
          T     = DAYNR -1
          BAYRD = 1
          BAYRY = YEAR
        ELSE
          CALL NRTODA (YEAR,DAYNR,M,D)
          CALL DATONR (YEAR,FMAY,1 ,FDAY)
          CALL DATONR (YEAR-1,FMAY,1,NRM1)
          IF (FMAY.LE.M) THEN
            T     = FROMTO (FDAY,YEAR,DAYNR,YEAR)  
            BAYRD = FDAY
            BAYRY = YEAR
          ELSE  
            T     = FROMTO (NRM1,YEAR-1,DAYNR,YEAR) 
            BAYRD = NRM1
            BAYRY = YEAR-1
          ENDIF  
        ENDIF
      ENDIF

C --- Read crop calendars once, expand number of runs in case of scaling
      IF (FLCAL) THEN

C ---   in case of no scaling read NOFRNS crop calendars
C ---   in case of scaling read 1 crop calendar 
        ITIMES = NOFRNS
        IF (SWSCAL.EQ.1) ITIMES = 1

        DO 2 I = 1,ITIMES
C ---     read crop calendar from CALFIL

C -       compose filename
          filnam = trim(envstr)//trim(calfil(i))//'.cal'

C ---     check if a crop calendar file has been specified
          IF (calfil(i)(1:4).EQ.'.CAL' .OR.
     &             len_trim(calfil(i)).EQ.0) THEN
            NOFCRP(I) = 0            
          ELSE

C ---       open and read calendar file
            cal = getun2 (10,19,2)
            call rdinit(cal,logf,filnam)
            call rdacha ('crpfil',crpflb,3,ifnd)
            call rdfinr ('Type',1,3,itype,3,ifnd)
            call rdfcha ('capfil',capflb,3,ifnd)
            call rdfinr ('d1_cal',1,31,d1,3,ifnd)
            call rdfinr ('m1_cal',1,12,m1,3,ifnd)
            call rdfinr ('d2_cal',1,31,d2,3,ifnd)
            call rdfinr ('m2_cal',1,12,m2,3,ifnd)
            call rdfinr ('d3_cal',1,31,d3,3,ifnd)
            call rdfinr ('m3_cal',1,12,m3,3,ifnd)
            close (cal)

            NOFCRP(I) = IFND    

C --- year is calculated, BRUNY moet eigenlijk BAYRY zijn
            DO 22 J = 1,IFND 
              if (m1(J) .GE. FMAY) y1(J) = BAYRY
              if (m1(J) .LT. FMAY) y1(J) = BAYRY+1
              if (BRUNY .ne. ERUNY) y1(J) = y1(J)+I-1
22          CONTINUE
C --- year is calculated
            DO 32 J = 1,IFND 
              if (m2(J).GE.FMAY) y2(J) = BAYRY
              if (m2(J).LT.FMAY) y2(J) = BAYRY+1
              if (BRUNY .ne. ERUNY) y2(J) = y2(J)+I-1
32          CONTINUE
C --- year is calculated
            DO 42 J = 1,IFND 
              if (m3(J).GE.FMAY) y3(J) = BAYRY
              if (m3(J).LT.FMAY) y3(J) = BAYRY+1
              if (BRUNY .ne. ERUNY) y3(J) = y3(J)+I-1
42          CONTINUE

            DO 4 J = 1,IFND
              CRPFIL(J,I) = CRPFLB(J)
              ICRMOD(J,I) = ITYPE(J)
              CAPFIL(J,I) = CAPFLB(J)
              BCRPY(J,I) = Y1(J)
              CALL DATONR (Y1(J),M1(J),D1(J),BCRPD(J,I))
              ECRPY(J,I) = Y2(J)
              CALL DATONR (Y2(J),M2(J),D2(J),ECRPD(J,I))
              BSCHY(J,I) = Y3(J)
              CALL DATONR (Y3(J),M3(J),D3(J),BSCHD(J,I))
4           CONTINUE


          ENDIF

2       CONTINUE

C ---   expand in case of scaling
        IF (SWSCAL.EQ.1) THEN
          CALL SHIFTL(OUTFIL(1))
          TMPNAM = OUTFIL(1)(1:14)
          Call SHIFTR(TMPNAM)
          DO 154 I = 1,NOFRNS
            IRGFIL(I) = IRGFIL(1)
            NOFCRP(I) = NOFCRP(1)
            DO 156 J = 1,NOFCRP(1)
              CRPFIL(J,I) = CRPFIL(J,1)
              ICRMOD(J,I) = ICRMOD(J,1)
              CAPFIL(J,I) = CAPFIL(J,1)
              BCRPY(J,I)  = BCRPY(J,1)
              BCRPD(J,I)  = BCRPD(J,1)
              ECRPY(J,I)  = ECRPY(J,1)
              ECRPD(J,I)  = ECRPD(J,1)
              BSCHY(J,I)  = BSCHY(J,1)
              BSCHD(J,I)  = BSCHD(J,1)
156         CONTINUE
            BBCFIL(I) = BBCFIL(1)
            DRFIL(I) = DRFIL(1)
C ---       Modify OUTFIL
            OUTFIL(I) = TMPNAM//EXT(I)          
154       CONTINUE
        ENDIF

      FLCAL = .FALSE.
      ENDIF

C --- Initialize flags, switches & counters ----------------------------

      FLOUT  = .FALSE.
      FLLAST = .FALSE.
      FLENDD = .FALSE.
      FLENDR = .FALSE.
      FLCROP = .FALSE.
      FLRAIC = .FALSE.
      FLCOPY = .TRUE.
      FLDTMIN = .FALSE.

      IRSTEP = 1
      ISTAGE = 1
      IRMODE = 1
      ID     = 0
      CRPNR  = 0
      NSTEPS = 0

C --- fill ICRMOD(0,??) with 0 (nu kan METEO worden aangeroepen met
C --- CRPNR = 0
      DO 17, I = 1,MAYRS
        ICRMOD(0,I) = 0
   17 continue

      IFINCR = 0

C --- first year only
      IF (RUNNR.EQ.1.OR.ISEQ.EQ.0) THEN

C ---   initial value counter output interval
        CNTPER = 1

        DAYNR  = BRUND
        DAYNRC = DAYNR 
        DAYSTA = BRUND
        TCUM   = DAYNR-1 
        YEAR   = BRUNY

        IF (DAYNR.EQ.BCRPD(1,RUNNR).AND.YEAR.EQ.BCRPY(1,RUNNR)) THEN
          CRPNR  = CRPNR+1
          ISTAGE = 2
          ID     = ID+1
          IF (DAYNR.EQ.BSCHD(1,RUNNR).AND.YEAR.EQ.BSCHY(1,RUNNR))
     &    IRMODE = 2
        ENDIF

C ---   calculate T, BAYRD,BAYRY
        IF (FMAY.EQ.1) THEN
          T     = DAYNR -1
          BAYRD = 1
          BAYRY = YEAR
        ELSE
          CALL NRTODA (YEAR,DAYNR,M,D)
          CALL DATONR (YEAR,FMAY,1 ,FDAY)
          CALL DATONR (YEAR-1,FMAY,1,NRM1)
          IF (FMAY.LE.M) THEN
            T     = FROMTO (FDAY,YEAR,DAYNR,YEAR)  
            BAYRD = FDAY
            BAYRY = YEAR
          ELSE  
            T     = FROMTO (NRM1,YEAR-1,DAYNR,YEAR) 
            BAYRD = NRM1
            BAYRY = YEAR-1
          ENDIF  
        ENDIF

        TM1  = T
        IF (IPORWL.EQ.1) THEN
          DT = 1.0d0
        ELSE
          DT   = SQRT (DTMIN*DTMAX)
        ENDIF
        DTM1 = DT

C --- following years
      ELSE

C ---   reset counter output interval
        IF (SWRES.EQ.1) CNTPER = 1

        DAYNR  = DAYNRO
        YEAR   = YEARO

        T      = 0
        BAYRD  = DAYNR
        BAYRY  = YEAR
        TM1    = T
        IF (IPORWL.EQ.1) THEN
          DT = 1.0d0
        ELSE
          DT     = SQRT (DTMIN*DTMAX)
        ENDIF
        DTM1   = DT
        IF (DAYNR.EQ.BCRPD(1,RUNNR).AND.YEAR.EQ.BCRPY(1,RUNNR)) THEN
          CRPNR  = CRPNR+1
          ISTAGE = 2
          ID     = ID+1
          IF (DAYNR.EQ.BSCHD(1,RUNNR).AND.YEAR.EQ.BSCHY(1,RUNNR))
     &    IRMODE = 2 
        ENDIF

      ENDIF

      if (IND.EQ.0) then
          IND = 1
          call showversion (Model_ID, Model_Date)
          write(*,11) trim(Model_ID), trim(Model_date)
  11      format(/,2x,a,2x,'(',a,')')
          if (swscre.eq.2) then
            write(*,12)
  12        format(/,'     Year DayNr DayNrCum',/)
          end if
      Endif

      RETURN

2000  CONTINUE

C === NEXT TIME STEP ===================================================

C === Check maximum number of time steps during this day
      NSTEPS = NSTEPS + 1
	IF (NSTEPS .GT. MSTEPS) THEN
        ErrScr = 'TIMER'
	  ErrTxt = 
     &    'Nr of tsteps for 1day (MSteps given in .SWA) is exceeded '
	  call SetFatalError (9999,errTxt,errScr)
	ENDIF

C === Decrease time step in case of no convergence in HEADCALC
      If (FlDecDt) then
        If (dt .gt. 3.0*dtmin) then
 	    dt = dt / 3.0
	  Else
          dt = dtmin
          FlDtMin = .True.
	  Endif
        FlDecDt = .False.
        if (fllast) fllast = .false.
        if (flraic) flraic = .false.
	  Return
	Endif

C === Decrease time step to DtMin if required by BOCOTOP
      If (FlDecDtMin) then
	  dt = dtmin
	  FlDecDtMin = .False.
        if (fllast) fllast = .false.
        if (flraic) flraic = .false.
	  Return
	Endif

C --- Update time T and cumulated time (ANIMO)
      T    = T + DT
      IF (IPORWL.EQ.2) TCUM = TCUM + DT

      IF (IPORWL.EQ.1) THEN
        DT     = 1.0d0
        FLENDD = .TRUE.
        GOTO 2900
      ENDIF

C --- store old value
      tm1  = t
      dtm1 = dt

C --- indicate t is at end of day
      if (FLLAST) then
         FLLAST = .FALSE.
         FLENDD = .TRUE.
      endif

C --- dt as determined by number of iterations needed to solve Richards equation
      if (numbit.lt.2) then
        if (qtop.gt.0.0) then
          dt = dt*1.25
        else
          dt = dt*1.1
        endif
      else
        if (numbit.gt.4) dt = dt/1.25
      endif

C --- dtmax as determined by solute transport
      if (swsolu.eq.1) dt = min (dt,dtsolu)

      IF (FLRAI.AND..NOT.FLENDD) THEN
        IF (FLRAIC) THEN
          ARFLUX = RAIFLX(IRSTEP+1)
          IRSTEP = IRSTEP+1
          FLRAIC = .FALSE.
        ENDIF 
        IF (T+DT.GT.(INT(T)+RAITIM(IRSTEP+1))-1.0d-4) THEN
          DT     = (INT(T)+RAITIM(IRSTEP+1))-T
          FLRAIC = .TRUE.
        ENDIF
      ENDIF

C --- limit dt at lower and upper boundary
      dt = max(dt,dtmin)
      dt = min(dt,dtmax)

C --- update FlDtMin
      if (dt .gt. 1.01*dtmin) FlDtMin = .false.

      IF (SWDRA.EQ.2) THEN
        IF (WLS.GT.PONDMX .OR. POND.GT.PONDMX) 
     &  dt = min(dt,(0.02*rsro))
      ENDIF

C --- if step is last timestep of the day : synchronise step
      if (t+1.2*dt.gt.aint(t+1.0d0)) then
        dt     = aint(t+1.0d0)-t
        FLLAST = .TRUE.
      endif

C --- at the end of the day determine whether today is output day
      IF (FLENDD) THEN
        FLOUT = .FALSE.
        IF (CNTPER .EQ. PERIOD) THEN
          CNTPER = 0
          FLOUT = .TRUE.
        ELSE  
          DO 20 I = 1,NOUTDA
            IF (DAYNR.EQ.OUTD(I).AND.YEAR.EQ.OUTY(I)) THEN
              FLOUT = .TRUE.
              GOTO 2900
            ENDIF
 20       CONTINUE
        ENDIF
      ENDIF

2900  CONTINUE

      RETURN

3000  CONTINUE

C === NEXT DAY =========================================================

C --- end of run?
      IF (DAYNR.EQ.ERUND.AND.YEAR.EQ.ERUNY) THEN
        FLENDR = .TRUE.
        DAYNR  = DAYNR+1
        GOTO 24
      ENDIF

C --- update daynumber
      DAYNR  = DAYNR+1
      IF (IPORWL.EQ.2) DAYNRC = DAYNRC+1
      FLENDD = .FALSE.
      IF (IPORWL.EQ.2) CNTPER = CNTPER + 1

C --- new calendar year ?
      CALL DATONR (YEAR,12,31,LDJY)
      IF (DAYNR.GT.LDJY) THEN
        DAYNR = 1
        YEAR  = YEAR+1
C ---   enable copying of meteofile to temporary file
        FLCOPY = .TRUE.
      ENDIF

C --- new agricultural year ?
      CALL DATONR (YEAR,FMAY,1,FDAY)
      IF (DAYNR.EQ.FDAY) THEN
        FLENDR = .TRUE.
        IF (IPORWL.EQ.2) THEN
          DAYNRO = DAYNR
          YEARO  = YEAR
        ENDIF
        GOTO 24
      ENDIF

C --- Determine current cropping stage & irrigation mode

      IF (IFINCR.GT.0) THEN
        IFINCR = 0
        ISTAGE = 1
        IRMODE = 1
        ID     = 0
        FLCROP = .FALSE.
      ENDIF

      IF (CRPNR.LT.NOFCRP(RUNNR)) THEN
        IF (DAYNR.EQ.BCRPD(CRPNR+1,RUNNR).AND.YEAR.EQ.
     &    BCRPY(CRPNR+1,RUNNR)) THEN
          CRPNR  = CRPNR+1
          ISTAGE = 2
        ENDIF
      ENDIF
      IF (CRPNR.GT.0) THEN
        IF (DAYNR.EQ.BSCHD(CRPNR,RUNNR).AND.YEAR.EQ.
     &  BSCHY(CRPNR,RUNNR)) IRMODE = 2
      ENDIF
      IF (ISTAGE.EQ.2) ID = ID+1

C --- reset counter for small rainfall timesteps 
24    IRSTEP = 1

C --- reset counter number of time steps during a day
      NSTEPS = 0

c --- reset timestep for next day
      dt = max(dt, sqrt(dtmin*dtmax))

      RETURN
      END 


