** FILE:
**    SWAMAIN.FOR - main program of SWAP
** FILE IDENTIFICATION:
**    $Id: SWAMAIN.FOR 2.3.1.16 2002/09/02 10:50:26Z Kroes Exp $
** DESCRIPTION:
**    This file contains the program unit SWAP, the main program of SWAP
************************************************************************
      PROGRAM SWAP
C ----------------------------------------------------------------------
      IMPLICIT NONE
      INCLUDE 'Param.Fi'

      INTEGER   cexf,BRUNY,BRUND,ERUNY,ERUND,FMAY,NOFRNS,DAYNR
      INTEGER   ICRMOD(0:3,MAYRS),DAYSTA,YEAR,LAYER(MACP)
      INTEGER   BAYRD,BAYRY,RUNNR,THETLO(MAHO),SWSOLU,SWETR
      INTEGER   SWSCAL,IDEV,DAYNRC,sw1fil,SWBALANCE
      INTEGER   BCRPY(3,MAYRS),BCRPD(3,MAYRS),ECRPY(3,MAYRS)
      INTEGER   ECRPD(3,MAYRS),BSCHY(3,MAYRS),BSCHD(3,MAYRS),CRPNR
      INTEGER   ID,IFINCR,IPORWL,IRMODE,ISEQ,ISTAGE,ISUA,NUMBIT
      INTEGER   NUMLAY,NUMNOD,LOGF,SWHEA,SWSHF,SWDRA,PERIOD,SWRES
      INTEGER   AFO,AUN,ATE,AIR,SWREDU,ISCLAY,SWHYST,SWCF,NOUTDA
      INTEGER   SWVAP,SWDRF,SWSWB,SWAFO,SWAUN,SWATE,SWAIR,SWGC,SWSCRE
      INTEGER   OUTD(1000),OUTY(1000),SWRAI,SWCFBS,MSTEPS
      INTEGER   BOTCOM(MAHO),NSCALE,SWMOBI,SWCRACK,SWDIVD,SWINCO
      integer*4 getun
      integer*2 status

      REAL*8    DZ(MACP),LAI,LAT,KDIF,NRAI,NIRD,RAITIM(100),RAIFLX(100)
      REAL*8    DISNOD(MACP+1),THETOL,ADCRH,ADCRL,ALT,ARFLUX,ATMDEM,CF
      REAL*8    CIRR,PSAND(MAHO),PSILT(MAHO),PCLAY(MAHO),ORGMAT(MAHO)
      REAL*8    DPTRA,DRZ,DT,DTM1,DTMAX,DTMIN,DQROT,DTSOLU,DVS,GIRD,GRAI
      REAL*8    HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,ECMAX,ECSLOP
      REAL*8    PEVA,PTRA,QTOP,RAD,RD,RDM,RDS,RELTR,RH,KDIR,COFAB
      REAL*8    T,TCUM,TAV,TAVD,TM1,TMNR,RDCTB(22),WLS,RSRO,POND,PONDMX
      REAL*8    COFRED,RSIGNI,RSC,GC
      REAL*8    FSCALE(MAYRS),PF1(MAHO),FM1(MAHO),PF2(MAHO),FM2(MAHO)
      REAL*8    SHRINA,MOISR1,THETCR(MAHO)
      REAL*8    MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,COFANI(MAHO)
      REAL*8    GWLI,CFBS, GWLCONV
      REAL*8    THETA(MACP),H(MACP),THETM1(MACP),HTABLE(MAHO,99),TAU
      REAL*8    COFGEN(8,MAHO),THETAS(MACP),THETAR(MACP),ALFAMG(MACP)
      REAL*8    THETIM(MAHO),HI(MACP)
 
      CHARACTER METFIL*15,ENVSTR*50
      CHARACTER*16 CRPFIL(3,MAYRS),CAPFIL(3,MAYRS),BBCFIL(MAYRS)
      CHARACTER*16 DRFIL(MAYRS),IRGFIL(MAYRS),CALFIL(MAYRS)
      CHARACTER*16 OUTFIL(MAYRS),SOLFIL(MAHO)
      CHARACTER*16 PRJNAM
      CHARACTER*16 AFONAM,AUNNAM,ATENAM,AIRNAM
      character*80 Model_ID,Model_date,PrjDes

      LOGICAL   FLENDD,FLENDR,FLOUT,FLLAST,FL1ST,FLGENU(MAHO),FLRAI
      LOGICAL   FLIRGE,FLIRGS,FLCROP,FLCAL,FLRAIC,FLRDME,FlDecDt
      LOGICAL   FlDecDtMin,FlDtMin,sw1crp, ToScr

C --- Error handling
      INTEGER GetErrorStatus
	EXTERNAL GetErrorStatus
C ----------------------------------------------------------------------
C --- INITIALIZATION

C --- delete existing file Swap.oke 
      call delfil ('Swap.oke',.false.)

C --- write message running to screen
      WRITE (*,'(/,A)') ' Running SWAP ....'

C --- Error handling initialization
      call ErrorInit

C --- Temporary solution to suppress crop-output to *.crp-files
      sw1crp = .false.

C --- open log file and write version control
      logf = getun (20,30)
      call fopens(logf,'SWAP.LOG','new','del')
      ToScr = .false.
      call messini(ToScr,.true.,logf)

c --- Read key-data about simulation and soil characteristics
      CALL RDKEY (PRJNAM,prjdes,ENVSTR,BRUNY,BRUND,ERUNY,
     &  ERUND,ISEQ,FMAY,PERIOD,SWRES,OUTD,OUTY,METFIL,LAT,ALT,SWETR,
     &  SWRAI,IRGFIL,CALFIL,DRFIL,BBCFIL,OUTFIL,NOFRNS,
     &  FLCAL,SWDRA,SWSOLU,SWHEA,SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,
     &  SWAUN,AUNNAM,SWATE,ATENAM,SWAIR,AIRNAM,SWSCRE,NOUTDA,sw1fil)

      CALL RDSWA (PRJNAM,ENVSTR,LOGF,PONDMX,SWREDU,COFRED,RSIGNI,
     &  DTMIN,DTMAX,THETOL,NUMLAY,NUMNOD,BOTCOM,DZ,SOLFIL,RDS,
     &  SWHYST,TAU,SWSCAL,NSCALE,ISCLAY,FSCALE,SWMOBI,PF1,FM1,PF2,FM2,
     &  THETIM,SWCRACK,SHRINA,MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,
     &  RAPCOEF,DIFDES,SWDIVD,COFANI,SWINCO,HI,GWLI,THETCR,PSAND,PSILT,
     &  PCLAY,ORGMAT,CFBS,SWCFBS,SWBALANCE,MSTEPS,GWLCONV)

C --- do simulation run NOFRNS times
      IF (SWSCAL.EQ.1) NOFRNS = NSCALE
      DO 1000 RUNNR = 1,NOFRNS

C --- do Potential part OR Water Limited part of one run
      DO 1000 IPORWL = 1,2

C ---   Initialize timer
        CALL TIMER (1,IPORWL,RUNNR,ISEQ,FMAY,BRUND,BRUNY,BCRPD,
     &  BCRPY,ECRPD,ECRPY,BSCHD,BSCHY,ERUND,ERUNY,IFINCR,DTMAX,
     &  NUMNOD,H,DTMIN,T,TCUM,TM1,DT,DTM1,ID,DAYNR,DAYSTA,YEAR,FLLAST,
     &  FLENDD,FLENDR,FLOUT,FLCROP,CRPNR,ISTAGE,IRMODE,BAYRD,BAYRY,
     &  RAITIM,RAIFLX,FLRAI,ARFLUX,SWSOLU,DTSOLU,NUMBIT,THETOL,QTOP,
     &  THETA,THETM1,NOFRNS,SWSCAL,FLCAL,CRPFIL,ICRMOD,CAPFIL,IRGFIL,
     &  CALFIL,BBCFIL,DRFIL,OUTFIL,ENVSTR,WLS,RSRO,SWDRA,POND,PONDMX,
     &  PERIOD,SWRES,FLRAIC,FLRDME,LOGF,OUTD,OUTY,NOUTDA,SWSCRE,
     &  DAYNRC,FLDECDT,FLDECDTMIN,FLDTMIN,MSTEPS,Model_ID,Model_date)

C ---   Initialize soil routine
        IF (IPORWL.EQ.2)
     &  CALL SOIL (1,prjdes,RUNNR,ISEQ,FLOUT,FL1ST,ENVSTR,
     &  SW1FIL,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &  BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,SWBALANCE,
     &  DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &  PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &  LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &  THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &  NUMBIT,THETOL,GWLCONV,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &  HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,WLS,
     &  RSRO,SWDRA,POND,PONDMX,AFO,AUN,ATE,AIR,PERIOD,
     &  SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &  SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &  SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,FlDecDtMin,FlDtMin,
     &  PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &  FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &  MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &  COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI,DAYNRC,CF,FlDecDt)
        if (GetErrorStatus().ne.0) goto 1100

C ---   Initialize irrigation routine, part 1
        IF (IPORWL.EQ.2) CALL IRRIG (1,ENVSTR,IRGFIL(RUNNR),
     &  OUTFIL(RUNNR),IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,GIRD,
     &  ISUA,CIRR,NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,HTABLE,
     &  THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &  CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY,sw1fil)

C --- BEGINNING OF A DAY -----------------------------------------------

100     CONTINUE

C ---   Initialize crop routine
        IF (ISTAGE.EQ.2.AND..NOT.FLCROP) THEN
          FLCROP = .TRUE.
          IF (ICRMOD(CRPNR,RUNNR).EQ.1) THEN
             CALL CROPS (1,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,TAV,DQROT,PTRA,RELTR,KDIF,KDIR,LAI,
     &      RD,IFINCR,ADCRH,ADCRL,DVS,HLIM1,HLIM2U,HLIM2L,HLIM3H,
     &      HLIM3L,HLIM4,RSC,RDCTB,RDM,ECMAX,ECSLOP,COFAB,LOGF,
     &      SWGC,GC,SWCF,CF,T,IDEV,sw1fil,sw1crp)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.2) THEN 
            CALL CROPD (1,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,CF,DVS,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,sw1fil,sw1crp)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.3) THEN
            CALL GRASS (1,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,CF,sw1fil,sw1crp)
          ENDIF
          DRZ = -RD
C ---     Initialize irrigation routine, part 2
          IF (IPORWL.EQ.2) CALL IRRIG (2,ENVSTR,IRGFIL(RUNNR),
     &      OUTFIL(RUNNR),IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,
     &      GIRD,ISUA,CIRR,NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,
     &      HTABLE,THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &      CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY,sw1fil)
        ELSEIF (ISTAGE.EQ.1) THEN
C ---     set 'nocrop conditions'
          CALL NOCROP (DRZ,LAI,CF,FLCROP)   
        ENDIF

C ---   Irrigation applied or required ?
        IF ((FLIRGE.OR.FLIRGS).AND.IPORWL.EQ.2) THEN
          CALL IRRIG (3,ENVSTR,IRGFIL(RUNNR),OUTFIL(RUNNR),
     &    IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,GIRD,ISUA,CIRR,
     &    NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,
     &    HTABLE,THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &    CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY,sw1fil)
        ELSE
          GIRD = 0.0
          ISUA = 0
        ENDIF

C ---   Intake of weather data
        CALL METEO (T,DT,IPORWL,YEAR,DAYNR,METFIL,ENVSTR,LAT,
     &  ALT,KDIF,KDIR,LAI,GIRD,ISUA,RAD,TAV,TAVD,TMNR,RH,GRAI,NRAI,
     &  NIRD,ATMDEM,PTRA,PEVA,RAITIM,RAIFLX,FLRAI,ARFLUX,CFBS,RSC,
     &  SWETR,ISTAGE,ICRMOD(CRPNR,RUNNR),LOGF,SWSHF,FLRAIC,COFAB,
     &  FLRDME,SWGC,GC,SWRAI,IDEV,SWCF,CF,SWCFBS)
        FL1ST = .TRUE.

C ---   Soil routine for one timestep

        Do while (.not.Flendd)
          IF (IPORWL.EQ.2) THEN
            CALL SOIL (2,prjdes,RUNNR,ISEQ,FLOUT,FL1ST,ENVSTR,
     &    SW1FIL,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &    BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,SWBALANCE,
     &    DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &    PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &    LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &    THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &    NUMBIT,THETOL,GWLCONV,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &    HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,WLS,
     &    RSRO,SWDRA,POND,PONDMX,AFO,AUN,ATE,AIR,PERIOD,
     &    SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &    SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &    SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,FlDecDtMin,FlDtMin,
     &    PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &    FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &    MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &    COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI,DAYNRC,CF,FlDecDt)
	    if (GetErrorStatus().ne.0) goto 1100
		ENDIF

C ---   Calculation of next timestep & total time
          CALL TIMER (2,IPORWL,RUNNR,ISEQ,FMAY,BRUND,BRUNY,BCRPD,
     &    BCRPY,ECRPD,ECRPY,BSCHD,BSCHY,ERUND,ERUNY,IFINCR,DTMAX,
     &    NUMNOD,H,DTMIN,T,TCUM,TM1,DT,DTM1,ID,DAYNR,DAYSTA,YEAR,FLLAST,
     &    FLENDD,FLENDR,FLOUT,FLCROP,CRPNR,ISTAGE,IRMODE,BAYRD,BAYRY,
     &    RAITIM,RAIFLX,FLRAI,ARFLUX,SWSOLU,DTSOLU,NUMBIT,THETOL,QTOP,
     &    THETA,THETM1,NOFRNS,SWSCAL,FLCAL,CRPFIL,ICRMOD,CAPFIL,IRGFIL,
     &    CALFIL,BBCFIL,DRFIL,OUTFIL,ENVSTR,WLS,RSRO,SWDRA,POND,PONDMX,
     &    PERIOD,SWRES,FLRAIC,FLRDME,LOGF,OUTD,OUTY,NOUTDA,SWSCRE,
     &    DAYNRC,FLDECDT,FLDECDTMIN,FLDTMIN,MSTEPS,Model_ID,Model_date)
        EndDo

C ---   Rates of crop growth & integrals of crop growth
        IF (ISTAGE.EQ.2) THEN
          IF (IPORWL.EQ.1)  DQROT = PTRA
          IF (ICRMOD(CRPNR,RUNNR).EQ.1) THEN
            CALL CROPS (2,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,TAV,DQROT,PTRA,RELTR,KDIF,KDIR,LAI,
     &      RD,IFINCR,ADCRH,ADCRL,DVS,HLIM1,HLIM2U,HLIM2L,HLIM3H,
     &      HLIM3L,HLIM4,RSC,RDCTB,RDM,ECMAX,ECSLOP,COFAB,LOGF,
     &      SWGC,GC,SWCF,CF,T,IDEV,sw1fil,sw1crp)
         ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.2) THEN 
            CALL CROPD (2,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,CF,DVS,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,sw1fil,sw1crp)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.3) THEN
            CALL GRASS (2,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,CF,sw1fil,sw1crp)
          ENDIF
          DRZ = -RD
C ---     terminal activities irrig
          IF (IFINCR.GT.1.AND.IPORWL.EQ.2) 
     &      CALL IRRIG (4,ENVSTR,IRGFIL(RUNNR),OUTFIL(RUNNR),
     &      IRMODE,YEAR,DAYNR,RELTR,ID,DVS,FLIRGE,FLIRGS,GIRD,ISUA,CIRR,
     &      NUMNOD,DZ,DRZ,HLIM3L,HLIM3H,HLIM4,LAYER,
     &      HTABLE,THETLO,H,DISNOD,FLGENU,COFGEN,THETAS,THETAR,ALFAMG,
     &      CAPFIL,CRPNR,RUNNR,LOGF,FMAY,BAYRY,sw1fil)
        ENDIF

C --- END OF A DAY -----------------------------------------------------

C ---   Write output files
        IF (IPORWL.EQ.2)
     &    CALL SOIL (3,prjdes,RUNNR,ISEQ,FLOUT,FL1ST,ENVSTR,
     &    SW1FIL,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &    BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,SWBALANCE,
     &    DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &    PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &    LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &    THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &    NUMBIT,THETOL,GWLCONV,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &    HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,WLS,
     &    RSRO,SWDRA,POND,PONDMX,AFO,AUN,ATE,AIR,PERIOD,
     &    SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &    SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &    SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,FlDecDtMin,FlDtMin,
     &    PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &    FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &    MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &    COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI,DAYNRC,CF,FlDecDt)
          if (GetErrorStatus().ne.0) goto 1100 

        IF (FLCROP .AND. IPORWL.EQ.2) THEN
          IF (ICRMOD(CRPNR,RUNNR).EQ.1) THEN
            CALL CROPS (3,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,TAV,DQROT,PTRA,RELTR,KDIF,KDIR,LAI,
     &      RD,IFINCR,ADCRH,ADCRL,DVS,HLIM1,HLIM2U,HLIM2L,HLIM3H,
     &      HLIM3L,HLIM4,RSC,RDCTB,RDM,ECMAX,ECSLOP,COFAB,LOGF,
     &      SWGC,GC,SWCF,CF,T,IDEV,sw1fil,sw1crp)
         ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.2) THEN 
            CALL CROPD (3,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,CF,DVS,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,sw1fil,sw1crp)
          ELSEIF (ICRMOD(CRPNR,RUNNR).EQ.3) THEN
            CALL GRASS (3,IPORWL,FLOUT,ID,DAYNR,YEAR,ENVSTR,
     &      CRPNR,CRPFIL(CRPNR,RUNNR),OUTFIL(RUNNR),ECRPY(CRPNR,RUNNR),
     &      ECRPD(CRPNR,RUNNR),RDS,RAD,TAV,TAVD,TMNR,DQROT,PTRA,RELTR,
     &      KDIF,KDIR,LAI,RD,IFINCR,ADCRH,ADCRL,ECMAX,ECSLOP,
     &      COFAB,LAT,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,HLIM4,RSC,
     &      RDCTB,RDM,LOGF,T,SWCF,CF,sw1fil,sw1crp)
          ENDIF
	  ENDIF

C ---   Update flags, switches and counters
        CALL TIMER (3,IPORWL,RUNNR,ISEQ,FMAY,BRUND,BRUNY,BCRPD,
     &  BCRPY,ECRPD,ECRPY,BSCHD,BSCHY,ERUND,ERUNY,IFINCR,DTMAX,
     &  NUMNOD,H,DTMIN,T,TCUM,TM1,DT,DTM1,ID,DAYNR,DAYSTA,YEAR,FLLAST,
     &  FLENDD,FLENDR,FLOUT,FLCROP,CRPNR,ISTAGE,IRMODE,BAYRD,BAYRY,
     &  RAITIM,RAIFLX,FLRAI,ARFLUX,SWSOLU,DTSOLU,NUMBIT,THETOL,QTOP,
     &  THETA,THETM1,NOFRNS,SWSCAL,FLCAL,CRPFIL,ICRMOD,CAPFIL,IRGFIL,
     &  CALFIL,BBCFIL,DRFIL,OUTFIL,ENVSTR,WLS,RSRO,SWDRA,POND,PONDMX,
     &  PERIOD,SWRES,FLRAIC,FLRDME,LOGF,OUTD,OUTY,NOUTDA,SWSCRE,
     &  DAYNRC,FLDECDT,FLDECDTMIN,FLDTMIN,MSTEPS,Model_ID,Model_date)

        IF (.NOT.FLENDR) GOTO 100

C --- END OF A SIMULATION RUN ------------------------------------------

C ---   Terminal activities soil
        IF (IPORWL.EQ.2)
     &  CALL SOIL (4,prjdes,RUNNR,ISEQ,FLOUT,FL1ST,ENVSTR,
     &  SW1FIL,OUTFIL(RUNNR),BBCFIL(RUNNR),DRFIL(RUNNR),
     &  BAYRY,BAYRD,DAYNR,ECMAX,ECSLOP,SWBALANCE,
     &  DAYSTA,YEAR,NUMLAY,NUMNOD,DZ,CIRR,T,TCUM,DT,DRZ,GRAI,GIRD,
     &  PEVA,PTRA,THETA,H,THETM1,TAV,DQROT,DPTRA,ADCRL,ADCRH,ATMDEM,
     &  LAYER,HTABLE,THETLO,DISNOD,NRAI,NIRD,FLGENU,COFGEN,
     &  THETAS,THETAR,ALFAMG,ARFLUX,SWSOLU,DTSOLU,DTMAX,DTMIN,
     &  NUMBIT,THETOL,GWLCONV,QTOP,HLIM1,HLIM2U,HLIM2L,HLIM3H,HLIM3L,
     &  HLIM4,RDCTB,RDM,BRUNY,ERUNY,BRUND,ERUND,SWHEA,WLS,
     &  RSRO,SWDRA,POND,PONDMX,AFO,AUN,ATE,AIR,PERIOD,
     &  SWREDU,COFRED,RSIGNI,SWSCAL,ISCLAY,SWHYST,TAU,
     &  SWVAP,SWDRF,SWSWB,SWAFO,AFONAM,SWAUN,AUNNAM,SWATE,ATENAM,
     &  SWAIR,AIRNAM,LOGF,SWSCRE,SWSHF,FlDecDtMin,FlDtMin,
     &  PRJNAM,BOTCOM,SOLFIL,PSAND,PSILT,PCLAY,ORGMAT,
     &  FSCALE,SWMOBI,PF1,FM1,PF2,FM2,THETIM,SWCRACK,SHRINA,
     &  MOISR1,MOISRD,ZNCRACK,GEOMF,DIAMPOL,RAPCOEF,DIFDES,SWDIVD,
     &  COFANI,SWINCO,HI,GWLI,FMAY,THETCR,GC,LAI,DAYNRC,CF,FlDecDt)
        if (GetErrorStatus().ne.0) goto 1100

1000  CONTINUE

1100  IF (GetErrorStatus().ne.0) then
        CALL WriteErrors(LOGF)
      ENDIF

C --- close ANIMO output files
      CLOSE (AFO)
      CLOSE (AUN)
      CLOSE (ATE)
      CLOSE (AIR)

c --- end of simulation
      write(*,*)
      IF (GetErrorStatus().ne.0) then
        call MessWrt (trim(model_ID),
     &             ' : simulation interrupted, see message above !!')
        write(*,*) ' ',trim(model_ID),
     &             ' : simulation interrupted, verify log-file !!'
      else
C       create file Swap.oke to let environment programs verify termination.
        cexf = getun (20,30)
        call fopens(cexf,'Swap.oke','new','del')
        write(cexf,*) 
     &     ' ',trim(model_ID)//' : simulation succesfully terminated!'
        Close (CEXF)
c       write final message to screen and log-file
        call MessWrt(trim(model_ID),
     &                           ' simulation succesfully terminated!')
        write(*,*) 
     &     ' ',trim(model_ID)//' : simulation succesfully terminated!'
      endif

c --- close temporary files
      cexf = getun (10,19)
      call rddtmp(cexf)

C --- close log file
      CLOSE (LOGF)

      END

      subroutine showversion(Model_ID,Model_Date)
************************************************************************
**    Routine: ShowVersion
**    Purpose: show version nr as defined by:
**             - model version nr
**             - Executable: path and filename of executable
**        - (hidden:Indentifier from archive medium (Revision Control System))
**    Usage:   Call ShowVersion(logf, model_ID, model_Date)
**    Author(s):   
**    Version:   
**    Date/history:
**    See also:
*     Arguments:
*     I/O Data_type Name         Meaning
*      I     I      logf         Unit number of log-file
*      O    C*80    Model_ID     Version of model
*      O    C*80    Model_Date   Date of version of the model
************************************************************************
C---- Declarations
      IMPLICIT NONE
c     global
      character*80 Model_ID, Model_Date
c     local
      character*80 rcs_ID, Executable
	integer*4    Date_Time(8)

C !!!! only place with model version and model date !!!!!!!!!!!!!!
      Model_ID   = 'Swap version 2.09d'
      Model_Date = 'September 2, 2002'
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

c     Identifier in archive medium (Revision Control System)
      RCS_ID = 
     &'$Id: SWAMAIN.FOR 2.3.1.16 2002/09/02 10:50:26Z Kroes Exp $'


      return
	end
      subroutine writehead(logf,ftype,prjdes)
************************************************************************
**    Routine: WriteHead
**    Purpose: Writes a header to unit nr logf, with the following info:
**              model version nr, simulation date, projectname
**    Usage:   Call WriteHead(logf,ftype,prjnam)
**    Author(s):   
**    Version:   
**    Date/history:
**    See also:
*     Arguments:
*     I/O Data_type Name         Meaning
*      I     I      logf         Unit number
*      I     I      ftype        File type (1=formatted or 2=unformatted)
*      I     C*80  prjdes       Project_ID (default: name of key-file)
************************************************************************
C---- Declarations
      IMPLICIT NONE
c     global
      integer       logf, ftype
      character*80  prjdes
c     local
      character*80  Model_ID, Model_Date, DTstring
	double precision DPactualTime
	integer*4     Date_Time(6)

c     get version number, but suppress output
      Call ShowVersion (Model_ID,Model_date)

      call DTnow (Date_Time)
	call DTardp (Date_Time, 0.0, DPactualTime)
      call DTdpst ('DAY-MONTHST-YEAR HOUR:MIN:SEC', DPactualTime, 
     &             DTstring)

c     Write to file
      if (ftype.eq.1) then
        write (logf,16)  trim(model_ID), trim(Model_date)
        write (logf,17)  trim(prjdes)
        write (logf,18)  trim(DTstring)
      else
        write (logf)  trim(model_ID), trim(Model_date)
        write (logf)  trim(prjdes)
        write (logf)  trim(DTstring)
      endif
   16 format(' Generated by:  ',a,2x,'(',a,')')
   17 format(' Project Name:  ',a)
   18 format(' Generated on:  ',a)

      return
	end
